﻿// MKFLMP3.cpp : このファイルには 'main' 関数が含まれています。プログラム実行の開始と終了がそこで行われます。
//

#define _CRT_RAND_S
#include <stdio.h>
#include <tchar.h>
#include <ctype.h>
#include <string.h>
#include <mbctype.h>
#include <mbstring.h>
#include <memory.h>
#include <windows.h>
#include <time.h>
#include <locale.h>
#include <id3tag.h>			// ..\madplay\libid3tag-0.15.1b
#include "Fontx.h"


#define		MAXLEN_DIRNAME			12			// DIR名長
#define		MAXLEN_DISPLAYNAME		32			// DIRの表示名長
#define		MAXLEN_TITLE			256			// 曲名の取得最大長(音源ファイルリストに出力する長さ(ML_TITLENAME)より大。取得値に含まれるアルバム名を切り捨てる可能性があるので。
#define		MAXLEN_DIRFULLPATH		128			// ディレクトリパスの最大UNICODE文字数
#define		MAXCHARS_DIRNAME		64			// ディレクトリの最大UNICODE文字数
#define		MAXCHARS_MP3_NAME		128			// MP3ファイルの最大UNICODE文字数

#define		BUFLEN					128
#define		MAX_DIRS				1000
#define		MAX_SUBDIRS				255			// １ディレクトリ下のサブディレクトリ数最大値
#define		MAX_MP3_FILES			255			// １ディレクトリ下のMP3ファイル数最大値
#define		NUM_RANDOMBYFILE		3			// ファイル単位でランダム再生するディレクトリの数
#define		MPEG_FRAME_BUFLEN		(1024*10)

#define		CODEC_MP3				1
#define		CODEC_AAC				2
#define		CODEC_M4A				3

#if PLAYER_VERSION==16 || PLAYER_VERSION==18
	#define		DISPLAY_DOT_WIDTH		128
#elif PLAYER_VERSION==12
	#define		DISPLAY_DOT_WIDTH		128
#else
#endif	// end of PLAYER_VERSION

// DIR構成ファイル　ファイル名
#if PLAYER_VERSION==16
	#define	DIRSTRUCTUREFILE			_T("DIRLST16.DAT")		// DIR構成ファイル(Version=16)
#elif PLAYER_VERSION==12
	#define	DIRSTRUCTUREFILE			_T("DIRLST12.DAT")		// DIR構成ファイル(Version=12)
#elif PLAYER_VERSION==15
	#define	DIRSTRUCTUREFILE			_T("DIRLST15.DAT")		// DIR構成ファイル(Version=15)
#elif PLAYER_VERSION==17
	#define	DIRSTRUCTUREFILE			_T("DIRLST17.DAT")		// DIR構成ファイル(Version=17)
#elif PLAYER_VERSION==18
	#define	DIRSTRUCTUREFILE			_T("DIRLST18.DAT")		// DIR構成ファイル(Version=18)
#else

#endif	// end of PLAYER_VERSION

// DIR構成ファイル　レコード長・項目別バイトサイズ
#if PLAYER_VERSION==16 || PLAYER_VERSION==12

#define	RECLEN_DIRLIST					512UL		// イメージ部分を除くレコード長
#define DL_DISPLAYNAME_LEN				32			// ディレクトリ表示名のバイト数
#define DL_FULLDIR_LEN					258		
#define DL_FULLDIRBYTES_LEN				2
#define DL_DIRNAME_LEN					130
#define DL_RECNO_SUBDIR_START_LEN		2
#define DL_NUM_SUBDIR_LEN				1
#define DL_RECNO_PARENTDIR_LEN			2
#define DL_RECNO_GRANDPARENTDIR_LEN		2
#define DL_NUM_SNDFILE_LEN				1
#define DL_RECNO_SNDFILE_LEN			2
#define DL_FILLER_LEN					80
#define DL_IMAGEDATA_LEN				512
#define DL_IMAGEDATAHALF_LEN			256

#elif PLAYER_VERSION==18

#define	RECLEN_DIRLIST					512UL		// イメージ部分を除くレコード長
#define DL_DISPLAYNAME_LEN				32			// ディレクトリ表示名のバイト数
#define DL_FULLDIR_LEN					258		
#define DL_FULLDIRBYTES_LEN				2
#define DL_DIRNAME_LEN					130
#define DL_RECNO_SUBDIR_START_LEN		2
#define DL_NUM_SUBDIR_LEN				1
#define DL_RECNO_PARENTDIR_LEN			2
#define DL_RECNO_GRANDPARENTDIR_LEN		2
#define DL_NUM_SNDFILE_LEN				1
#define DL_RECNO_SNDFILE_LEN			2
#define DL_FILLER_LEN					78
#define DL_IMAGELENGTH_LEN				2
#define DL_IMAGEDATA_LEN				512
#define DL_IMAGEDATAHALF_LEN			256

#elif PLAYER_VERSION==15

#define	RECLEN_DIRLIST					192UL		// レコード長
#define DL_DISPLAYNAME_LEN				32			// ディレクトリ表示名(SJIS)のバイト数
#define	MAXCHARS_DIRNAMEU				30			// ディレクトリ表示名(UNICODE)の最大文字数
#define	DL_DISPLAYNAMEU_LEN				62
#define DL_FULLDIR_LEN					61		
#define DL_FULLDIRBYTES_LEN				1
#define DL_DIRNAME_LEN					13
#define DL_RECNO_SUBDIR_START_LEN		2
#define DL_NUM_SUBDIR_LEN				1
#define DL_RECNO_PARENTDIR_LEN			2
#define DL_RECNO_GRANDPARENTDIR_LEN		2
#define DL_NUM_SNDFILE_LEN				1
#define DL_RECNO_SNDFILE_LEN			2
#define DL_FILLER_LEN					13

#define	RECORD_RENAME_DIR_FILE			_T("RENDIR.TXT")		// ディレクトリ名変更記録
//	#define RENAME_RECORD_FILE				_T("RENAME15.TXT")		// ディレクトリとファイルの名前変更記録
#define	RENAME_RECORD_BUF_SIZE			1024

#elif PLAYER_VERSION==17

#define	RECLEN_DIRLIST					512UL		// レコード長
#define DL_DISPLAYNAME_LEN				32			// ディレクトリ表示名のバイト数
#define DL_FULLDIR_LEN					258			// ディレクトリフルパス
#define DL_FULLDIRBYTES_LEN				2			// ディレクトリフルパスバイト数
#define DL_DIRNAME_LEN					130			// ディレクトリ名
#define DL_RECNO_SUBDIR_START_LEN		2			// サブディレクトリの先頭レコード番号
#define DL_NUM_SUBDIR_LEN				1			// サブディレクトリ数
#define DL_RECNO_PARENTDIR_LEN			2			// 親ディレクトリのレコード番号
#define DL_RECNO_GRANDPARENTDIR_LEN		2			// 親々ディレクトリのレコード番号
#define DL_NUM_SNDFILE_LEN				1			// MP3ファイル数
#define DL_RECNO_SNDFILE_LEN			2			// MP3ファイルリスト先頭レコード番号
#define DL_FILLER_LEN					80

#endif	// end of PLAYER_VERSION

// 音源ファイルリスト　ファイル名
#if PLAYER_VERSION==16
	#define	SNDFILELISTFILE				_T("SNDLST16.DAT")		// MP3ファイルリスト(Version=16)
#elif PLAYER_VERSION==12
	#define	SNDFILELISTFILE				_T("SNDLST12.DAT")		// MP3ファイルリスト(Version=12)
#elif PLAYER_VERSION==15
	#define	SNDFILELISTFILE				_T("SNDLST15.DAT")		// MP3ファイルリスト(Version=15)
#elif PLAYER_VERSION==17
	#define	SNDFILELISTFILE				_T("SNDLST17.DAT")		// MP3ファイルリスト(Version=17)
#elif PLAYER_VERSION==18
	#define	SNDFILELISTFILE				_T("SNDLST18.DAT")		// MP3ファイルリスト(Version=18)
#endif	// end of PLAYER_VERSION

// 音源ファイルリスト　項目サイズ
#if PLAYER_VERSION==16 || PLAYER_VERSION==12

	#define	RECLEN_MP3LIST					352UL					// イメージ部分を除くレコード長
	#define ML_TITLENAME_LEN				48
	#define ML_FILENAME_LEN					258
	#define ML_FILLER_LEN					46
	#define ML_IMAGEDATA_LEN				768UL
	#define ML_IMAGEDATAHALF_LEN			384UL

#elif PLAYER_VERSION==18

	#define	RECLEN_MP3LIST					352UL					// イメージ部分を除くレコード長
	#define ML_TITLENAME_LEN				48
	#define ML_FILENAME_LEN					258
	#define ML_FILLER_LEN					44
	#define ML_IMAGELENGTH_LEN				2
	#define ML_IMAGEDATA_LEN				768UL
	#define ML_IMAGEDATAHALF_LEN			384UL

#elif PLAYER_VERSION==15

	#define	RECLEN_MP3LIST					128UL					// イメージ部分を除くレコード長
	#define ML_TITLENAME_LEN				32
	#define ML_TITLENAMEU_LEN				74
	#define ML_FILENAME_LEN					13
	#define ML_TIMESEC_LEN					2
	#define	ML_FILESIZE_LEN					4
	//#define ML_RATE_LEN						2
	#define ML_TAGSIZE_LEN					2
	#define ML_FILLER_LEN					1
	#define ML_IMAGEDATA_LEN				0UL
	#define ML_IMAGEDATAHALF_LEN			0UL

	#define	RECORD_RENAME_MP3_FILE		_T("RENMP3.TXT")		// ディレクトリ名変更記録

#elif PLAYER_VERSION==17

#define	RECLEN_MP3LIST					640UL		// 
#define ML_TITLENAME_LEN				48			// 曲名表示名
#define ML_FILENAME_LEN					258			// MP3ファイル名
#define ML_TITME_LEN					258			// 曲名
#define ML_TIMESEC_LEN					2
#define ML_FILLER_LEN					74

#endif	// end of PLAYER_VERSION

// タグ情報ファイル
#if PLAYER_VERSION == 15
	#define SNDTAGINFFILE				_T("SNDTAG15.DAT")		

	#define	TI_FILENAME_LEN			26
	#define	TI_TITLE_LEN			520
	#define TI_TITLELEN_LEN			2
	#define TI_TIMESEC_LEN			2
	#define TI_SAMPLINGRATE_LEN		2
	#define TI_MPEGFRAMECOUNT_LEN	4
	#define	TI_TAGSIZE_LEN			2
	#define TI_FILLER_LEN			18

#endif

// ランダム再生順ファイル
#if PLAYER_VERSION==16
	#define	RANDOMORDERFILE				_T("RANDOM16.DAT")
	#define RANDOMBYFILE				_T("")
#elif PLAYER_VERSION==12
	#define	RANDOMORDERFILE				_T("RANDOM12.DAT")
	#define RANDOMBYFILE				_T("")
#elif PLAYER_VERSION==15
	#define	RANDOMORDERFILE				_T("RANDOM15.DAT")
	#define RANDOMBYFILE				_T("MP3_15_RANDOM_BY_FILE.INF")
#elif PLAYER_VERSION==17
	#define	RANDOMORDERFILE				_T("RANDOM17.DAT")
#elif PLAYER_VERSION==18
	#define	RANDOMORDERFILE				_T("RANDOM18.DAT")
	#define RANDOMBYFILE				_T("")
#else
#endif	// end of PLAYER_VERSION

// ランダム再生順テキスト出力
#define	RANDOMORDERLOG					_T("RANDOM.TXT")

// MP3_15設定ファイル
#if PLAYER_VERSION==15
	#define	INIFILE						"\\CONFIG15.INI"
	#define	CONFIGFILE					_T("\\CONFIG15.DAT")
#endif	// end of PLAYER_VERSION

// 固定文字列ファイル/メニューイメージファイル
#if PLAYER_VERSION==16
	#define	MESSAGESTRINGFILE			_T("MSGSTR16.DAT")
	#define MS_IMAGEDATA_LEN			256UL
	#define MS_IMAGEDATAHALF_LEN		128UL
	#define	MS_SJIS_MAXLEN				16
#elif PLAYER_VERSION==12
	#define	MESSAGESTRINGFILE			_T("MSGSTR12.DAT")
	#define MS_IMAGEDATA_LEN			256UL
	#define	MENUDAT12					_T("MNUDAT12.DAT")		// メニューデータファイル
	#define	MS_SJIS_MAXLEN				22
#elif PLAYER_VERSION==18
	#define	MESSAGESTRINGFILE			_T("MSGSTR18.DAT")
	#define MS_IMAGEDATA_LEN			256UL
	#define MS_IMAGEDATAHALF_LEN		128UL
	#define	MS_SJIS_MAXLEN				16
#else
#endif	// end of PLAYER_VERSION


#define	DEBUGFILE			_T("DEBUG.TXT")

// フォントファイル
#define	FONT_FILE_ZEN_16_16		_T("_FONT\\MYRCZ16B.FNT")
#define FONT_FILE_HAN_8_16		_T("_FONT\\MYRCH16B.FNT")
#define	FONT_FILE_ZEN_12_12		_T("_FONT\\DRUG12Z1.FEF")
#define	FONT_FILE_HAN_6_12		_T("_FONT\\DRUG12HN.FEF")

// ディレクトリ構成解析作業用
typedef struct _DirInfo {
	char*				dirname_mbs;			// 表示ディレクトリ名（SJIS。ディレクトリパスを含まない）
	WCHAR*				dirname_w;				// 表示ディレクトリ名（UNICODE。ディレクトリパスを含まない。）
	WCHAR*				dirname;				// 実在ディレクトリ名（ディレクトリパスを含まない。）
	USHORT				recno_thisdir;			// 本ディレクトリのレコード番号
	USHORT				recno_subdir_start;		// サブディレクトリの先頭レコード番号
	int					num_subdir;				// サブディレクトリ数
	struct _DirInfo*	subdirinfo;				// サブディレクトリ情報
	int					num_sndfile;			// 音源ファイル数
	USHORT				recno_sndfile;			// 音源ファイルリスト先頭レコード番号
	struct _DirInfo*	parentdirinfo;			// 親ディレクトリ情報
	int					randomunit;				// ランダム再生 再生単位
} DIRINFO;

// MP3ファイルリスト作成作業用
typedef struct _Mp3Info {
	WCHAR*				name_w;			// 表示曲名またはファイル名(UNICODE)
	WCHAR*				filename;		// 実在ファイル名
	WCHAR*				title;			// MP3タグ タイトル
	int					titlelen;		// 同　文字数
	unsigned long		paddedsize;		// ID3タグ部分の総バイト数
	int					time_sec;		// 長さ（秒）
	unsigned int		sampling_rate;	// サンプリングレート
	unsigned long		mpeg_frame_count;	// MPEGフレーム数
	unsigned long		filesize;		// ファイルサイズ(バイト)
	int					codec;			// エンコーディング
} MP3INFO;

// ランダム再生順決定作業用
typedef struct _RandomOrder {
	BYTE				unit;		// 再生単位　0:フォルダ単位、1:ファイル単位
	USHORT				recno_dir;	// ディレクトリレコード番号
	BYTE				trackno;	// 音源ファイルの曲番号
} RANDOMORDER;

// ファイル名変更リスト
typedef struct _RenameList {
	WCHAR				oldname[MAXCHARS_MP3_NAME + 1];
	WCHAR				newname[MAXCHARS_MP3_NAME + 1];
	struct _RenameList* next;
} RENAMELIST;

// タグ情報
typedef struct _SndTagInf {
	WCHAR*				name;			// 実在ファイル名
	WCHAR*				title;			// MP3タグ タイトル
	int					titlelen;		// 同　文字数
	int					time_sec;		// 長さ（秒）
//	unsigned long		filesize;
	unsigned int		sampling_rate;	// サンプリングレート
	unsigned long		mpeg_frame_count;	// MPEGフレーム数
	unsigned long		paddedsize;		// ID3タグ部分の総バイト数
	struct _SndTagInf*	next;
} SNDTAGINF;

USHORT		NumDirs;				// ディレクトリ総数(明細レコード総数)取得ワーク変数
USHORT		NumSndDirs;				// MP3ファイルを持つディレクトリ総数取得ワーク変数
USHORT		RecNoThisDir;			// ディレクトリのレコード番号採番ワーク変数
USHORT		RecNoSndFile;			// 音源ファイルのレコード番号採番ワーク変数
USHORT		NumRndItems;			// ランダム再生順項目数
RANDOMORDER	*RndOrderTable;			// ランダム再生順作成テーブル
WCHAR*		RandomByFile[NUM_RANDOMBYFILE];		// ファイル単位でランダム再生するディレクトリ

FONTMETRICS		FontZen;
FONTMETRICS		FontHan;

FILE* Fdl;		// DIR構成ファイル
FILE* Fml;		// 音源ファイル
FILE* Ftitle;	// 曲名リストファイル
FILE* Finf;		// タグ情報取得ファイル
//FILE* Fdb;		// デバッグ情報
_locale_t locale_Ja_Jp;

BOOL CreateDirectoryStructureFile();
BOOL GetSubDirInfo(LPCWSTR targetdirpath, DIRINFO* info);
void ConvertAltString(const WCHAR* orgStr, WCHAR* altStr);
BOOL ConvertWcsToMbs(char* mbstr, size_t sizeInBytes, const wchar_t* wcstr);
BOOL ConvertWcsToMbs2(char* mbstr, size_t sizeInBytes, const wchar_t* wcstr);
BOOL ConvertMbsToWcs(char* mbstr, wchar_t* wcstr, size_t sizeInWords);
BOOL WriteDirStructureFileH();
BOOL WriteDirStructureFileRoot(DIRINFO* info);
BOOL WriteDirStructureFileM(LPCWSTR targetdirpath, DIRINFO* info);
int compare_dirinfo(const void* dir1, const void* dir2);
int compare_mp3filename(const void* file1, const void* file2);
void SetDirInfo(DIRINFO* info);
DIRINFO* GetDirInfo(DIRINFO* info, USHORT recno);
BOOL InitFont();
BOOL IsRandomByFileDir(LPCWSTR dirpath);
void CreateRandomOrder(DIRINFO* info);
USHORT DiffRecNoRndOrderTable(RANDOMORDER* order1, RANDOMORDER* order2);
int SetRandomOrderTable(DIRINFO* info, int idx);
void CreateMessageStringFile();
void CreateMenuData12();
void getID3TagInfo(LPCWSTR inFolder, LPCWSTR mp3, WCHAR* title, int titlebufsize, int* titlelen, unsigned long* paddedsize);
void getID3TagInfoTest(FILE* fout, LPCWSTR inFolder, LPCWSTR mp3);
void getMpegFrameHeaderInfo(LPCWSTR inFolder, LPCWSTR mp3, unsigned int id3v2_tag_size, int* time_sec,
	unsigned int* sampling_rate, unsigned long* mpeg_frame_count);
unsigned long getIrregularTagSize(LPCWSTR inFolder, LPCWSTR mp3, int* time_sec,
	unsigned int* sampling_rate, unsigned long* mpeg_frame_count);
void getAacFrameHeaderInfo(LPCWSTR inFolder, LPCWSTR mp3, int* time_sec);
//int GetRealDurationAdts(unsigned char buf[], int start, int length);
int GetRealDurationAdts(unsigned char buf[], int start, int length, int* duration, long start_pos);
void RenameSubdir(LPCWSTR targetdirpath, DIRINFO* info, int num_dir);
void RenameMp3File(LPCWSTR targetdirpath, MP3INFO mp3list[], int num_mp3);
void WriteTagInfFile(LPCWSTR targetdirpath, MP3INFO mp3list[], int num_mp3);
SNDTAGINF* GetSndTagInfList(LPCWSTR targetdirpath);
void FreeSndTagInfList(SNDTAGINF* p);
BOOL CheckNameW_8_3(WCHAR* name);
BOOL CheckCharW_8_3(WCHAR c);
void MakeDirnameW_8_3(WCHAR* name, WCHAR* canname, int* seqno, int* fileno);
BOOL RecordDirnameChange(WCHAR* dirpath, WCHAR* oldname);
BOOL GetDirNameBeforeRename(WCHAR* dirname_w, WCHAR* dirpath);
BOOL RecordMp3FilenameChange(const WCHAR* dirpath, WCHAR* oldname, WCHAR* newname);
RENAMELIST* GetMp3FilenameChangeList(const WCHAR* dirpath);
void CreateConfigFile();


//int main(int argc, char *argv[])
int wmain(int argc, wchar_t* argv[])
{
	int		i;

	//if (_wfopen_s(&Fdb, DEBUGFILE, _T("w")) != 0 || Fdb == NULL) {
	//	printf("fopen error\n");
	//	return FALSE;
	//}

#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
	InitFont();
#endif	// end of PLAYER_VERSION

	if (argc > 1) {
		LPWSTR p1 = GetCommandLineW();
		LPWSTR p2;
		int i = 0;

		while (1) {
			p2 = wcschr(p1, _T('\\'));		// 最初の￥＝ルートを探す
			if (p2 == NULL) break;
			p1 = wcschr(p2, _T('"'));		// 閉じる ”を探す
			if (p1 == NULL) break;
			*p1 = _T('\0');
			RandomByFile[i] = (WCHAR*)malloc(sizeof(WCHAR) * BUFLEN);
			if (RandomByFile[i] == NULL) break;
			_tcscpy_s(RandomByFile[i], BUFLEN, p2);
			i++;
			if (i == NUM_RANDOMBYFILE) break;
			p1++;
		}
		
	}
	//fclose(Fdb);

	if (_wfopen_s(&Fml, SNDFILELISTFILE, _T("wb")) != 0 || Fml == NULL) {
		printf("fopen error\n");
		return FALSE;
	}
	if (_wfopen_s(&Ftitle, _T("TITLE16.TXT"), _T("w")) != 0 || Ftitle == NULL) {	// MP3_16/15/18の動作に必須のファイルではない
		printf("fopen error\n");
		return FALSE;
	}	
#if !defined(_DEBUG)
	if (_wfopen_s(&Finf, _T("\\TAGINF.TXT"), _T("wt")) != 0 || Finf == NULL) {
		printf("fopen error\n");
		return FALSE;
	}
#endif

	locale_Ja_Jp = _create_locale(LC_ALL, "ja-JP");
	CreateDirectoryStructureFile();
	fclose(Fml);
	fclose(Ftitle);
#if !defined(_DEBUG)
	fclose(Finf);
#endif

#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
	CreateMessageStringFile();
#endif

#if PLAYER_VERSION==15
	CreateConfigFile();
#endif

//#if PLAYER_VERSION==12
//	CreateMenuData12();
//#endif

}


/*
 *	ディレクトリ構成ファイル作成
 */
BOOL CreateDirectoryStructureFile() {
	DIRINFO	rootdirinfo;

	RecNoSndFile = 0;
	NumRndItems = 0;

	// ルートディレクトリ
	memset(&rootdirinfo, 0, sizeof(DIRINFO));
	rootdirinfo.dirname = (WCHAR*)malloc(sizeof(WCHAR) * (MAXCHARS_DIRNAME + 1));
	if (rootdirinfo.dirname == NULL) return FALSE;
	_tcscpy_s(rootdirinfo.dirname, MAXCHARS_DIRNAME + 1, _T(""));
	rootdirinfo.dirname_w = (WCHAR*)malloc(sizeof(WCHAR) * (MAXCHARS_DIRNAME + 1));
	if (rootdirinfo.dirname_w == NULL) return FALSE;
	_tcscpy_s(rootdirinfo.dirname_w, MAXCHARS_DIRNAME + 1, _T(""));
	rootdirinfo.dirname_mbs = (char *)malloc(DL_DISPLAYNAME_LEN + 1);
	if (rootdirinfo.dirname_mbs == NULL) return FALSE;
	ConvertWcsToMbs(rootdirinfo.dirname_mbs, DL_DISPLAYNAME_LEN + 1, rootdirinfo.dirname_w);

	// サブディレクトリ・ツリー
#if !defined(_DEBUG)
	GetSubDirInfo(_T(""), &rootdirinfo);		// 実運用時
#else
	GetSubDirInfo(_T("D:"), &rootdirinfo);		// デバッグ実行時
#endif

	// ディレクトリ間連携情報設定
	RecNoThisDir = 1;
	rootdirinfo.recno_thisdir = RecNoThisDir++;
	SetDirInfo(&rootdirinfo);

	// ランダム再生順作成
	CreateRandomOrder(&rootdirinfo);

	printf("WriteDirStructureFileM\n");
	// DIR構成ファイル出力
	if (_wfopen_s(&Fdl, DIRSTRUCTUREFILE, _T("wb")) != 0 || Fdl == NULL) {
		printf("fopen error\n");
		return FALSE;
	}

	WriteDirStructureFileH();
	WriteDirStructureFileRoot(&rootdirinfo);
	WriteDirStructureFileM(_T(""), &rootdirinfo);	// 明細レコード
	fclose(Fdl);

	return TRUE;
}


/*
 *	対象ディレクトリの下のサブディレクトリ情報を取得
 */
BOOL GetSubDirInfo(LPCWSTR targetdirpath, DIRINFO *info) {
	HANDLE	hFind;
	WIN32_FIND_DATA FindFileData;
	WCHAR	searchfile[MAXLEN_DIRFULLPATH];
	MP3INFO	mp3list[MAX_MP3_FILES];
	int		titlelen_min;
	int		title_start_idx;
	int		trackno_flg;
	int		num_dir = 0;
	int		num_mp3 = 0;
	int		i;
	int		j;
#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
	static BYTE	imagedata[ML_IMAGEDATA_LEN];
	USHORT	img_length;
#endif
	SNDTAGINF* taginflist;
	SNDTAGINF* tp;
#if PLAYER_VERSION==17
	WCHAR	disptitleU[MAX_PATH];
#endif

	printf("GetSubDirInfo=[%s]\n", info->dirname_mbs);
#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
	if (IsRandomByFileDir(targetdirpath) == TRUE) {
		info->randomunit = 1;
		printf(" ファイル単位\n");
	}
#elif PLAYER_VERSION==15
	swprintf_s(searchfile, MAXLEN_DIRFULLPATH, _T("%s\\%s"), targetdirpath, RANDOMBYFILE);
	if (GetFileAttributesW(searchfile) != INVALID_FILE_ATTRIBUTES) {
		info->randomunit = 1;
		printf(" ファイル単位\n");
	}
#endif

	// 対象ディレクトリの下の全ディレクトリと全ファイルを列挙する
	swprintf_s(searchfile, MAXLEN_DIRFULLPATH, _T("%s\\*.*"), targetdirpath);
	hFind = FindFirstFileEx(searchfile, /*FindExInfoMaxInfoLevel*/ FindExInfoBasic, &FindFileData, FindExSearchNameMatch, NULL, 1);
	if (hFind != INVALID_HANDLE_VALUE) {
		info->num_subdir = 0;
		info->subdirinfo = (DIRINFO*)malloc(sizeof(DIRINFO) * MAX_SUBDIRS);
		if (info->subdirinfo == NULL) return FALSE;
		memset(info->subdirinfo, 0, sizeof(DIRINFO) * MAX_SUBDIRS);
		info->num_sndfile = 0;
		do {
			// ディレクトリ
			if (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
				if (_tcscmp(FindFileData.cFileName, _T(".")) != 0 && _tcscmp(FindFileData.cFileName, _T("..")) != 0
						&& FindFileData.cFileName[0] != '_'
						&& _tcslen(FindFileData.cFileName) <= MAXCHARS_DIRNAME) {
					// 実在ディレクトリ名(UNICODE)
					info->subdirinfo[num_dir].dirname = (WCHAR*)malloc(sizeof(WCHAR) * (MAXCHARS_DIRNAME + 1));
					if (info->subdirinfo[num_dir].dirname == NULL) return FALSE;
					memset(info->subdirinfo[num_dir].dirname, 0, sizeof(WCHAR) * (MAXCHARS_DIRNAME + 1));
					_tcscpy_s(info->subdirinfo[num_dir].dirname, MAXCHARS_DIRNAME + 1, FindFileData.cFileName);
					// 表示ディレクトリ名(UNICODE)
					info->subdirinfo[num_dir].dirname_w = (WCHAR*)malloc(sizeof(WCHAR) * (MAXCHARS_DIRNAME + 1));
					if (info->subdirinfo[num_dir].dirname_w == NULL) return FALSE;
					memset(info->subdirinfo[num_dir].dirname_w, 0, sizeof(WCHAR) * (MAXCHARS_DIRNAME + 1));
					_tcscpy_s(info->subdirinfo[num_dir].dirname_w, MAXCHARS_DIRNAME + 1, FindFileData.cFileName);	// 実在ディレクトリで初期化
					// 表示ディレクトリ名(SJIS)
					info->subdirinfo[num_dir].dirname_mbs = (char *)malloc(DL_DISPLAYNAME_LEN + 1);
					if (info->subdirinfo[num_dir].dirname_mbs == NULL) return FALSE;
					if (_tcsnicmp(info->subdirinfo[num_dir].dirname_w, _T("disk"), 4) == 0 ||
						_tcsnicmp(info->subdirinfo[num_dir].dirname_w, _T("disc"), 4) == 0) {		// disk/discで始まるディレクトリ名は、その親ディレクトリ名を繋いで表示名とする
						WCHAR	dirname_tmp[MAXLEN_TITLE];
						swprintf_s(dirname_tmp, MAXLEN_TITLE, _T("%s|%s"), info->subdirinfo[num_dir].dirname_w, info->dirname_w);
						ConvertWcsToMbs(info->subdirinfo[num_dir].dirname_mbs, DL_DISPLAYNAME_LEN + 1, dirname_tmp);
					}
					else {
						ConvertWcsToMbs(info->subdirinfo[num_dir].dirname_mbs, DL_DISPLAYNAME_LEN + 1, info->subdirinfo[num_dir].dirname_w);
					}
					// 
					num_dir++;
					NumDirs++;
				}
			}
			// ファイル
			else if (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE){
				WCHAR*	c;
				c = wcsrchr(FindFileData.cFileName, '.');
				if (c != NULL) {
					if ((_wcsicmp(c, _T(".mp3")) == 0 
#if PLAYER_VERSION==15 || PLAYER_VERSION==17
						|| _wcsicmp(c, _T(".aac")) == 0
						|| _wcsicmp(c, _T(".m4a")) == 0
#endif						
						) && _tcslen(FindFileData.cFileName) <= MAXCHARS_MP3_NAME) {

						if (num_mp3 < MAX_MP3_FILES) {
							if (_wcsicmp(c, _T(".mp3")) == 0) {
								mp3list[num_mp3].codec = CODEC_MP3;
							} else if (_wcsicmp(c, _T(".aac")) == 0) {
								mp3list[num_mp3].codec = CODEC_AAC;
							} else if (_wcsicmp(c, _T(".m4a")) == 0) {
								mp3list[num_mp3].codec = CODEC_M4A;
							}

							// MP3ファイル名(UNICODE)
							mp3list[num_mp3].filename = (WCHAR*)malloc(sizeof(WCHAR) * MAX_PATH);
							if (mp3list[num_mp3].filename == NULL) return FALSE;
							memset(mp3list[num_mp3].filename, 0, sizeof(WCHAR) * MAX_PATH);
							_tcscpy_s(mp3list[num_mp3].filename, MAX_PATH, FindFileData.cFileName);
							// 表示ファイル名(UNICODE)
							mp3list[num_mp3].name_w = (WCHAR*)malloc(sizeof(WCHAR) * MAX_PATH);
							if (mp3list[num_mp3].name_w == NULL) return FALSE;
							memset(mp3list[num_mp3].name_w, 0, sizeof(WCHAR) * MAX_PATH);
							_tcscpy_s(mp3list[num_mp3].name_w, MAX_PATH, FindFileData.cFileName);	// 実ファイル名で初期化
							// ファイルサイズ
							mp3list[num_mp3].filesize = FindFileData.nFileSizeLow;
							// TEST
							//swprintf_s(mp3fullpath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), targetdirpath, FindFileData.cFileName);
							//fwrite(mp3fullpath, sizeof(WCHAR), 128, Ftitle);
							num_mp3++;
							if (num_mp3 == 1) {
								NumSndDirs++;
							}
							if (info->randomunit == 0) {	// ディレクトリ単位のランダム再生
								if (num_mp3 == 1) {
									NumRndItems++;
								}
							}
							else {		// 曲単位のランダム再生
								NumRndItems++;
							}
						}
					}
				}
			}
		} while (FindNextFileW(hFind, &FindFileData));

		FindClose(hFind);

#if PLAYER_VERSION==15
		// ディレクトリ名変更
		if (num_dir > 0) {
			RenameSubdir(targetdirpath, info, num_dir);
		}
		// MP3ファイル名変更
		if (num_mp3 > 0) {
			RenameMp3File(targetdirpath, mp3list, num_mp3);
		}
#endif

		// サブディレクトリをソート
		if (num_dir > 0) {
			qsort(info->subdirinfo, num_dir, sizeof(DIRINFO), compare_dirinfo);
			for (i = 0; i < num_dir; i++) {
				info->subdirinfo[i].parentdirinfo = info;
			}
		}
		// MP3ファイルをソート
		if (num_mp3 > 0) {
			info->recno_sndfile = RecNoSndFile;
			qsort(mp3list, num_mp3, sizeof(MP3INFO), compare_mp3filename);
			//qsort(mp3list, num_mp3, sizeof(WCHAR*), compare_mp3filename);
		}
		info->num_subdir = num_dir;
		info->num_sndfile = num_mp3;

		// タグ情報からタイトル名取得
#if PLAYER_VERSION==15
		taginflist = GetSndTagInfList(targetdirpath);		// 保存済みタグ情報があれば取得
#elif PLAYER_VERSION==17
		taginflist = NULL;
#endif
		titlelen_min = MAX_PATH;
		for (i = 0; i < num_mp3; i++) {
			mp3list[i].title = (WCHAR*)malloc(sizeof(WCHAR) * MAX_PATH);
			if (mp3list[i].title == NULL) return FALSE;
			memset(mp3list[i].title, 0, sizeof(WCHAR)* MAX_PATH);

#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
			getID3TagInfo(targetdirpath, mp3list[i].filename, mp3list[i].title, MAX_PATH, &(mp3list[i].titlelen), &(mp3list[i].paddedsize));
			if (mp3list[i].titlelen < titlelen_min) titlelen_min = mp3list[i].titlelen;		// タイトル文字数の最小値
			//getID3TagInfoTest(Finf, targetdirpath, mp3list[i].name);
#elif PLAYER_VERSION==15 || PLAYER_VERSION==17
			for (tp = taginflist; tp != NULL; tp = tp->next) {
				if (wcscmp(tp->name, mp3list[i].name_w) == 0) {
					wcscpy_s(mp3list[i].title, MAX_PATH, tp->title);
					mp3list[i].titlelen = tp->titlelen;
					mp3list[i].time_sec = tp->time_sec;
					mp3list[i].sampling_rate = tp->sampling_rate;
					mp3list[i].mpeg_frame_count = tp->mpeg_frame_count;
					if (mp3list[i].titlelen < titlelen_min) titlelen_min = mp3list[i].titlelen;		// タイトル文字数の最小値
					break;
				}
			}
			if (tp == NULL) {
				if (mp3list[i].codec == CODEC_MP3) {
					//getID3TagInfoTest(Finf, targetdirpath, mp3list[i].name);
					getID3TagInfo(targetdirpath, mp3list[i].name_w, mp3list[i].title, MAX_PATH, &(mp3list[i].titlelen), &(mp3list[i].paddedsize));
					if (mp3list[i].titlelen < 0) mp3list[i].titlelen = 0;
					if (mp3list[i].titlelen < titlelen_min) titlelen_min = mp3list[i].titlelen;		// タイトル文字数の最小値
					getMpegFrameHeaderInfo(targetdirpath, mp3list[i].name_w, mp3list[i].paddedsize, &(mp3list[i].time_sec),
						&(mp3list[i].sampling_rate), &(mp3list[i].mpeg_frame_count));
					// getMpegFrameHeaderInfoで不明のときの代替
					if (mp3list[i].time_sec == 0 || mp3list[i].mpeg_frame_count == 0) {
						mp3list[i].paddedsize = getIrregularTagSize(targetdirpath, mp3list[i].name_w, &(mp3list[i].time_sec)
							, &(mp3list[i].sampling_rate), &(mp3list[i].mpeg_frame_count));
						printf("tagsize=%ld, sampling_rate=%ld frame_count=%ld second=%d (Irregular)\n",
							mp3list[i].paddedsize, mp3list[i].sampling_rate, mp3list[i].mpeg_frame_count, mp3list[i].time_sec);
					} else {
						printf("tagsize=%ld, sampling_rate=%ld frame_count=%ld second=%d\n",
							mp3list[i].paddedsize, mp3list[i].sampling_rate, mp3list[i].mpeg_frame_count, mp3list[i].time_sec);
					}
				} else if (mp3list[i].codec == CODEC_AAC || mp3list[i].codec == CODEC_M4A) {
					mp3list[i].titlelen = 0;
					if (mp3list[i].titlelen < titlelen_min) titlelen_min = mp3list[i].titlelen;		// タイトル文字数の最小値
					mp3list[i].paddedsize = 0;
					mp3list[i].time_sec = 0;
					mp3list[i].sampling_rate = 0;
					mp3list[i].mpeg_frame_count = 0;
					if (mp3list[i].codec == CODEC_AAC) {
						getAacFrameHeaderInfo(targetdirpath, mp3list[i].name_w, &(mp3list[i].time_sec));
					} else {
						mp3list[i].time_sec = 0;
					}
				}
			}
#endif
		}
		//printf(" titlelen_min=%d\n", titlelen_min);
		title_start_idx = 0;
		trackno_flg = 0;
		if (num_mp3 > 0 && titlelen_min > 0) {		// 全ての曲についてタグからタイトルを取得できた
			int		n;
			WCHAR	c;
			for (i = 0; i < titlelen_min; i++) {
				c = mp3list[0].title[i];	// １曲目のi番目の文字
				for (j = 1; j < num_mp3; j++) {		// ２曲目以降の同位置の文字と比較
					if (mp3list[j].title[i] != c) break;
				}
				if (j < num_mp3) {		// 一致しない文字がある
					// i番目の文字から不一致。 0～(i-1)番目の文字は全ての曲で一致している
					title_start_idx = i;
					break;
				}
			}
			//printf(" title_start_idx=%d\n", title_start_idx);
			
			// タイトル名から一致部分を除いて、タイトル名とする
			if (title_start_idx > 0) {
				for (i = 0; i < num_mp3; i++) {
					WCHAR	titlelist_work[MAX_PATH];
					memset(titlelist_work, 0, MAX_PATH);
					wcscpy_s(titlelist_work, MAX_PATH, &mp3list[i].title[title_start_idx]);
					wcscpy_s(mp3list[i].title, MAX_PATH, titlelist_work);
					mp3list[i].titlelen -= title_start_idx;
				}
			}

			// タイトルに最初から曲番号がついているかどうかを判定する
			n = (num_mp3 < 10 ? num_mp3 : 9);		// 最初の最大９曲で判定
			for (i = 0; i < n; i++) {
				if (mp3list[i].title[0] != ('1' + i)) {
						break;
				}
			}
			if (i >= n) {	
				trackno_flg = 1;		// タイトルに曲番号付き
			}
			else {
				// ２ケタの曲番号をチェック
				for (i = 0; i < n; i++) {
					if (!(mp3list[i].title[0] == '0' && mp3list[i].title[1] == ('1' + i))) {
							break;
					}
				}
				if (i >= n) {
					trackno_flg = 1;		// タイトルに曲番号付き
				}
			}
		}

		// 音源ファイルリストに出力
		fprintf(Ftitle, "DIR [%s]\n", info->dirname_mbs);
		for (i = 0; i < num_mp3; i++) {
			char	mp3file_mbs[ML_TITLENAME_LEN + 1];
			char	mp3file_mbs_2[ML_TITLENAME_LEN + 1];
			int		len_2 = 0;

			// 曲名表示名(SJIS) & 曲名表示名(UNICODE)
			ConvertWcsToMbs(mp3file_mbs, ML_TITLENAME_LEN + 1, mp3list[i].name_w);		// ファイル名のSJIS
			printf(" [%s] second=%d\n", mp3file_mbs, mp3list[i].time_sec);
			if (trackno_flg == 0 && mp3list[i].titlelen > 0) {		// タイトルに曲番号なし
				WCHAR	title_tmp[MAX_PATH];

				printf("  No No. in title (%d)\n", mp3list[i].titlelen);
				swprintf_s(title_tmp, MAX_PATH, _T("%d %s"), i+1, mp3list[i].title);	// 曲番号付加
				if (ConvertWcsToMbs(mp3file_mbs_2, ML_TITLENAME_LEN + 1, title_tmp) == TRUE) {
					fwrite(mp3file_mbs_2, 1, ML_TITLENAME_LEN, Fml);	// 曲名表示名(SJIS)＝連番＋タグタイトル
					fprintf(Ftitle, "1:[%s][%s]\n", mp3file_mbs, mp3file_mbs_2);
#if PLAYER_VERSION==15
					fwrite(title_tmp, 1, ML_TITLENAMEU_LEN, Fml);		// 曲名表示名(UNICODE)＝連番＋タグタイトル
#elif PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
					// イメージデータ作成（表示タイトル名に基づく）
					MakeLcdDataOfString(imagedata, ML_IMAGEDATA_LEN, (unsigned char*)mp3file_mbs_2, ML_TITLENAME_LEN, &img_length, &FontHan, &FontZen);
#elif PLAYER_VERSION==17
					wcscpy_s(disptitleU, title_tmp);
#endif
				} else {
					fwrite(mp3file_mbs, 1, ML_TITLENAME_LEN, Fml);		// 曲名表示名(SJIS)＝ファイル名
#if PLAYER_VERSION==15
					fwrite(title_tmp, 1, ML_TITLENAMEU_LEN, Fml);	// 曲名表示名(UNICODE)＝連番＋タグタイトル
#elif PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
					// イメージデータ作成（表示タイトル名に基づく）
					MakeLcdDataOfString(imagedata, ML_IMAGEDATA_LEN, (unsigned char*)mp3file_mbs, ML_TITLENAME_LEN, &img_length, &FontHan, &FontZen);
#elif PLAYER_VERSION==17
					wcscpy_s(disptitleU, title_tmp);
#endif
					fprintf(Ftitle, "2:[%s]\n", mp3file_mbs);
				}

			} else if (trackno_flg == 1 && mp3list[i].titlelen > 2) {		// タイトルに曲番号付きだが、タイトル名が曲番だけ、という名前は除外する
				printf("  With No. in title, but No only\n");
				if (ConvertWcsToMbs(mp3file_mbs_2, ML_TITLENAME_LEN + 1, mp3list[i].title) == TRUE) {
					fwrite(mp3file_mbs_2, 1, ML_TITLENAME_LEN, Fml);	// 曲名表示名(SJIS)＝タグタイトル
#if PLAYER_VERSION==15
					fwrite(mp3list[i].title, 1, ML_TITLENAMEU_LEN, Fml);	// 曲名表示名(UNICODE)＝タグタイトル
#elif PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
					// イメージデータ作成（表示タイトル名に基づく）
					MakeLcdDataOfString(imagedata, ML_IMAGEDATA_LEN, (unsigned char*)mp3file_mbs_2, ML_TITLENAME_LEN, &img_length, &FontHan, &FontZen);
#elif PLAYER_VERSION==17
					wcscpy_s(disptitleU, mp3list[i].title);
#endif
					fprintf(Ftitle, "3:[%s][%s]\n", mp3file_mbs, mp3file_mbs_2);
				} else {
					fwrite(mp3file_mbs, 1, ML_TITLENAME_LEN, Fml);		// 曲名表示名(SJIS)＝ファイル名
#if PLAYER_VERSION==15
					fwrite(mp3list[i].title, 1, ML_TITLENAMEU_LEN, Fml);	// 曲名表示名(UNICODE)＝タグタイトル
#elif PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
					// イメージデータ作成（表示タイトル名に基づく）
					MakeLcdDataOfString(imagedata, ML_IMAGEDATA_LEN, (unsigned char*)mp3file_mbs, ML_TITLENAME_LEN, &img_length, &FontHan, &FontZen);
#elif PLAYER_VERSION==17
					wcscpy_s(disptitleU, mp3list[i].title);
#endif
					fprintf(Ftitle, "4:[%s]\n", mp3file_mbs);
				}

			} else {	// タグタイトル無し
				printf("  No tag title\n");
				fwrite(mp3file_mbs, 1, ML_TITLENAME_LEN, Fml);			// 曲名表示名(SJIS)＝ファイル名
#if PLAYER_VERSION==15
				fwrite(mp3list[i].name_w, 1, ML_TITLENAMEU_LEN, Fml);		// 曲名表示名(UNICODE)＝ファイル名
#elif PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
				// イメージデータ作成（表示タイトル名に基づく）
				MakeLcdDataOfString(imagedata, ML_IMAGEDATA_LEN, (unsigned char*)mp3file_mbs, ML_TITLENAME_LEN, &img_length, &FontHan, &FontZen);
#elif PLAYER_VERSION==17
				wcscpy_s(disptitleU, mp3list[i].name_w);
#endif
				fprintf(Ftitle, "5:[%s]\n", mp3file_mbs);
			}
			// 実ファイル名
#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
			fwrite(mp3list[i].filename, 1, ML_FILENAME_LEN, Fml);
#elif PLAYER_VERSION==15
			ConvertWcsToMbs2(mp3file_mbs, ML_TITLENAME_LEN + 1, mp3list[i].name);		// 実ファイル名のSJIS (8.3)
			fwrite(mp3file_mbs, 1, ML_FILENAME_LEN, Fml);
			fwrite(&(mp3list[i].time_sec), 1, ML_TIMESEC_LEN, Fml);
			fwrite(&(mp3list[i].filesize), 1, ML_FILESIZE_LEN, Fml);
			fwrite(&(mp3list[i].paddedsize), 1, ML_TAGSIZE_LEN, Fml);
#elif PLAYER_VERSION==17
			fwrite(mp3list[i].filename, 1, ML_FILENAME_LEN, Fml);
			fwrite(disptitleU, 1, ML_TITME_LEN, Fml);
			fwrite(&(mp3list[i].time_sec), 1, ML_TIMESEC_LEN, Fml);
#endif
			for (int j = 0; j < ML_FILLER_LEN; j++) {
				fputc(0, Fml);
			}
#if PLAYER_VERSION==16 || PLAYER_VERSION==12
			// イメージデータ出力
			fwrite(imagedata, 1, ML_IMAGEDATA_LEN, Fml);
#elif PLAYER_VERSION==18
			fwrite(&img_length, 1, ML_IMAGELENGTH_LEN, Fml);
			// イメージデータ出力
			fwrite(imagedata, 1, ML_IMAGEDATA_LEN, Fml);
#endif

			RecNoSndFile++;
		}

#if PLAYER_VERSION==15
		if (num_mp3 > 0) {
			WriteTagInfFile(targetdirpath, mp3list, num_mp3);
		}
		FreeSndTagInfList(taginflist);
#endif

		//
		for (i = 0; i < num_mp3; i++) {
			free(mp3list[i].filename);
			free(mp3list[i].name_w);
			free(mp3list[i].title);
		}

		// 再帰的にサブディレクトリ情報
		for (i = 0; i < num_dir; i++) {
			WCHAR	searchsubfile[MAXLEN_DIRFULLPATH];
			swprintf_s(searchsubfile, MAXLEN_DIRFULLPATH, _T("%s\\%s"), targetdirpath, info->subdirinfo[i].dirname);
			GetSubDirInfo(searchsubfile, &(info->subdirinfo[i]));
		}
		// サブディレクトリ／ファイルどちらも持たないサブディレクトリを排除する
		for (i=0, j=0; i < num_dir; i++) {
			if (info->subdirinfo[i].num_subdir != 0 || info->subdirinfo[i].num_sndfile != 0) {
				if (i != j) {
					memcpy(&(info->subdirinfo[j]), &(info->subdirinfo[i]), sizeof(DIRINFO));
				}
				j++;
			}
		}
		info->num_subdir = j;
	}
	return TRUE;

}

/*
 *	DIR構成ファイルのレコード番号を決める
 */
void SetDirInfo(DIRINFO* info) {
	int		i;

	for (i = 0; i < info->num_subdir; i++) {
		info->subdirinfo[i].recno_thisdir = RecNoThisDir++;
		info->subdirinfo[i].parentdirinfo = info;
		if (info->subdirinfo[i].num_sndfile > 0) {
			printf("SetDirInfo %x %x, %x %x \n", info->subdirinfo[i].recno_thisdir, info->subdirinfo[i].recno_thisdir * 0x300,
				info->subdirinfo[i].recno_sndfile, info->subdirinfo[i].recno_sndfile * 0x400);
		}
	}
	if (info->num_subdir > 0) {
		info->recno_subdir_start = info->subdirinfo[0].recno_thisdir;
	}

	for (i = 0; i < info->num_subdir; i++) {
		SetDirInfo(&(info->subdirinfo[i]));
	}
}

/*
 *	指定されたRECNOを持つDIRINFOを取得する。
 */
DIRINFO* GetDirInfo(DIRINFO* info, USHORT recno) {
	int		i;
	DIRINFO* ret;

	if (info->recno_thisdir == recno) {
		return info;
	}
	for (i = 0; i < info->num_subdir; i++) {
		ret = GetDirInfo(&(info->subdirinfo[i]), recno);
		if (ret != NULL) return ret;
	}
	return NULL;
}


/*
 *	ランダム再生順作成
 */
void CreateRandomOrder(DIRINFO* info) {
	int		idx = 0;
	unsigned int	rnumer1, rnumer2;
	USHORT	diff, min_diff;
	int		total_loop;
	int		i, j;
	RANDOMORDER		w;
	FILE* fp = NULL;
	FILE* fplog = NULL;

	RndOrderTable = (RANDOMORDER*)malloc(sizeof(RANDOMORDER) * NumRndItems);
	idx = SetRandomOrderTable(info, idx);
	total_loop = idx * 10;
	min_diff = NumRndItems / 20;

//	for (i = 0; i < NumRndItems; i++) {
//		printf("RND-B %d, %x, %d\n", RndOrderTable[i].unit, RndOrderTable[i].recno_dir, RndOrderTable[i].trackno);
//	}
	for (i = 0; i < total_loop; i++) {
		rand_s(&rnumer1);
		rand_s(&rnumer2);
		rnumer1 %= idx;
		rnumer2 %= idx;

		memcpy(&w, &RndOrderTable[rnumer1], sizeof(RANDOMORDER));
		memcpy(&RndOrderTable[rnumer1], &RndOrderTable[rnumer2], sizeof(RANDOMORDER));
		memcpy(&RndOrderTable[rnumer2], &w, sizeof(RANDOMORDER));
	}

	if (NumRndItems > 100) {
		// 件数が多いときだけ追加のランダム調整を行う。
		for (i = 1; i < NumRndItems; i++) {
			j = i - 1;
			// iとjのrecnoの差
			diff = DiffRecNoRndOrderTable(&RndOrderTable[i], &RndOrderTable[j]);

			if (diff < min_diff) {
				for (int n = 0; n < 10; n++) {		// トライアルループ
					unsigned int	k;
					rand_s(&k);
					k %= idx;
					if (k > i && DiffRecNoRndOrderTable(&RndOrderTable[j], &RndOrderTable[k]) > min_diff) {
						// iをkと入れ替える。iより後ろと入れ替えるので、後ろほど調整の余地が無くなる
						memcpy(&w, &RndOrderTable[i], sizeof(RANDOMORDER));
						memcpy(&RndOrderTable[i], &RndOrderTable[k], sizeof(RANDOMORDER));
						memcpy(&RndOrderTable[k], &w, sizeof(RANDOMORDER));
						break;
					}
				}
			}
			//printf("RND-A %d, %x, %d\n", RndOrderTable[i].unit, RndOrderTable[i].recno_dir, RndOrderTable[i].trackno);
		}
	}
	//printf("CreateRandomOrder %d %d\n", NumRndItems, idx);

	if (_wfopen_s(&fp, RANDOMORDERFILE, _T("wb")) != 0 || fp == NULL) {
		printf("fopen error\n");
		return;
	}
	if (_wfopen_s(&fplog, RANDOMORDERLOG, _T("wt, ccs=UNICODE")) != 0 || fplog == NULL) {
		printf("fopen error\n");
		return;
	}
	for (i = 0; i < idx; i++) {
		DIRINFO* p = GetDirInfo(info, RndOrderTable[i].recno_dir);
		fwprintf(fplog, _T("%d %d (%s) %d\n"), RndOrderTable[i].unit, RndOrderTable[i].recno_dir, p->dirname_w, RndOrderTable[i].trackno);
		//printf("RND-A %d, %x, %d\n", RndOrderTable[i].unit, RndOrderTable[i].recno_dir, RndOrderTable[i].trackno);

		fwrite(&(RndOrderTable[i].unit), 1, 1, fp);
		fwrite(&(RndOrderTable[i].recno_dir), 1, 2, fp);
		fwrite(&(RndOrderTable[i].trackno), 1, 1, fp);
	}
	fclose(fp);
	fclose(fplog);
}

/*
 *	RANDOMORDERのrecno_dirの差
 */
USHORT DiffRecNoRndOrderTable(RANDOMORDER *order1, RANDOMORDER* order2) {
	USHORT diff;

	if (order1->recno_dir > order2->recno_dir) {
		diff = order1->recno_dir - order2->recno_dir;
	}
	else {
		diff = order2->recno_dir - order1->recno_dir;
	}
	return diff;	
}

int SetRandomOrderTable(DIRINFO* info, int idx) {
	if (info->num_sndfile > 0) {
		printf(" SetRandomOrderTable %d, %x %x, %x %x \n", info->randomunit, info->recno_thisdir, info->recno_thisdir * 0x300, info->recno_sndfile, info->recno_sndfile * 0x400);
		if (info->randomunit == 0) {
			RndOrderTable[idx].unit = 0;
			RndOrderTable[idx].recno_dir = info->recno_thisdir;
			RndOrderTable[idx].trackno = 0;
			idx++;
		}
		else {
			for (int i = 0; i < info->num_sndfile; i++) {
				RndOrderTable[idx].unit = 1;
				RndOrderTable[idx].recno_dir = info->recno_thisdir;
				RndOrderTable[idx].trackno = i;
				idx++;
			}
		}
	}

	for (int i = 0; i < info->num_subdir; i++) {
		idx = SetRandomOrderTable(&(info->subdirinfo[i]), idx);
	}

	return idx;
}
	

/*
 *	MBS文字列に変換できないUNICODE文字列について代替文字列を作成する
 */
void ConvertAltString(const WCHAR* orgStr, WCHAR* altStr) {
	int strLen = _tcslen(orgStr);
	int	i;
	int	retVal;
	char	dummy[4];

	for (i = 0; i < strLen; i++) {
		if (_wctomb_s_l(&retVal, dummy, 4, orgStr[i], locale_Ja_Jp) == 0) {	// 変換可能
			altStr[i] = orgStr[i];
		}
		else {
			altStr[i] = '?';
		}
	}
	altStr[strLen] = '\0';
}


/*
 *	UNICODE文字列をMBS文字列に変換。MBS文字列はバッファ末尾まで半角スペースで埋め、NULL終端とする。
 */
BOOL ConvertWcsToMbs(char* mbstr, size_t sizeInBytes, const wchar_t* wcstr) {
	size_t	retVal;
	int		i;
	BOOL	nullFlg = FALSE;

	_wcstombs_s_l(&retVal, mbstr, sizeInBytes, wcstr, sizeInBytes - 1, locale_Ja_Jp);
	if (retVal == 0) {
		//WCHAR	altName[MAX_PATH];

		fprintf(Ftitle, "cannot convert \n");
		return FALSE;
		//ConvertAltString(wcstr, altName);
		//_wcstombs_s_l(&retVal, mbstr, sizeInBytes, altName, sizeInBytes - 1, locale_Ja_Jp);
		//if (retVal == 0) {
		//	_wcstombs_s_l(&retVal, mbstr, sizeInBytes, _T("???"), sizeInBytes - 1, locale_Ja_Jp);
		//}
	}
	if (retVal == 0) return FALSE;
	for (i = retVal-1; i < sizeInBytes; i++) {
			if (i == (sizeInBytes - 1)) {
				mbstr[i] = 0;		// NULL終端
			}
			else {
				mbstr[i] = 0x20;	// space
			}
	}
	return TRUE;
}


/*
 *	UNICODE文字列をMBS文字列に変換。MBS文字列は半角スペースで埋めしないで、NULL終端とする。
 */
BOOL ConvertWcsToMbs2(char* mbstr, size_t sizeInBytes, const wchar_t* wcstr) {
	size_t	retVal;
	//int		i;
	BOOL	nullFlg = FALSE;

	_wcstombs_s_l(&retVal, mbstr, sizeInBytes, wcstr, sizeInBytes - 1, locale_Ja_Jp);
	if (retVal == 0) {
		//WCHAR	altName[MAX_PATH];

		//fprintf(Ftitle, "cannot convert \n");
		mbstr[0] = 0;		// NULL終端
		return FALSE;
		//ConvertAltString(wcstr, altName);
		//_wcstombs_s_l(&retVal, mbstr, sizeInBytes, altName, sizeInBytes - 1, locale_Ja_Jp);
		//if (retVal == 0) {
		//	_wcstombs_s_l(&retVal, mbstr, sizeInBytes, _T("???"), sizeInBytes - 1, locale_Ja_Jp);
		//}
	}
	//if (retVal == 0) return FALSE;
	mbstr[retVal - 1] = 0;		// NULL終端
	//for (i = retVal - 1; i < sizeInBytes; i++) {
	//	if (i == (sizeInBytes - 1)) {
	//		mbstr[i] = 0;		// NULL終端
	//	}
	//	else {
	//		mbstr[i] = 0x20;	// space
	//	}
	//}
	return TRUE;
}


/*
 *	MBS文字列をUNICODE文字列に変換
 */
BOOL ConvertMbsToWcs(char* mbstr, wchar_t* wcstr, size_t sizeInWords) {
	size_t	retVal;

	if (_mbstowcs_s_l(&retVal, wcstr, sizeInWords, mbstr, sizeInWords - 1, locale_Ja_Jp) == 0) {
		wcstr[retVal] = 0;
	} else {
		wcstr[0] = 0;
	}
	return TRUE;
}

/*
 *	DIRINFOの配列をdirname_wでソートするための比較関数
 */
int compare_dirinfo(const void* dir1, const void* dir2) {
	DIRINFO* dirinfo1 = (DIRINFO*)dir1;
	DIRINFO* dirinfo2 = (DIRINFO*)dir2;

	if (dirinfo1 != NULL && dirinfo2 != NULL) {
		return _tcscmp(dirinfo1->dirname_w, dirinfo2->dirname_w);
	}
	else if (dirinfo1 == NULL) {
		return +1;
	}
	else {
		return -1;
	}
}

/*
 *	MP3ファイル名ソートのための比較関数
 */
int compare_mp3filename(const void* file1, const void* file2) {
	MP3INFO* pfile1 = (MP3INFO*)(file1);
	MP3INFO* pfile2 = (MP3INFO*)(file2);
	//WCHAR* pfile1 = *(WCHAR**)(file1);
	//WCHAR* pfile2 = *(WCHAR**)(file2);

	if (pfile1 != NULL && pfile2 != NULL) {
		return _tcscmp(pfile1->name_w, pfile2->name_w);
		//return _tcscmp(pfile1, pfile2);
	}
	else if (pfile1 == NULL || pfile2 == NULL) {
		return +1;
	}
	else {
		return -1;
	}
}

/*
 *	DIR構成ファイルヘッダレコード書き出し
 */
BOOL WriteDirStructureFileH() {
	time_t ltime;
	struct tm today;
	WCHAR	crdt[32];
	char	crdt_mbs[32];
	size_t	retVal;

	time(&ltime);
	_localtime64_s(&today, &ltime);
	swprintf_s(crdt, 32, _T("%04d%02d%02d%02d%02d%02d"), today.tm_year + 1900, today.tm_mon + 1, today.tm_mday, today.tm_hour, today.tm_min, today.tm_sec);
	wcstombs_s(&retVal, crdt_mbs, 32, crdt, 32);

	fwrite(&NumDirs, 1, 2, Fdl);
	fwrite(&NumSndDirs, 1, 2, Fdl);
	fwrite(crdt_mbs, 1, 14, Fdl);
#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
	for (int j = 0; j < (RECLEN_DIRLIST - 2 - 2 - 14); j++) {			// 512 - 18 = 494
		fputc(0, Fdl);
	}
	for (int j = 0; j < DL_IMAGEDATA_LEN; j++) {
		fputc(0, Fdl);
	}
#elif PLAYER_VERSION==15
	for (int j = 0; j < 174; j++) {
		fputc(0, Fdl);
	}
#elif PLAYER_VERSION==17
	for (int j = 0; j < (RECLEN_DIRLIST - 18); j++) {
		fputc(0, Fdl);
	}
#endif

	return TRUE;
}

/*
 *	DIR構成ファイル明細ルートレコード書き出し
 */
BOOL WriteDirStructureFileRoot(DIRINFO* info) {
	WCHAR	dirfullpath[MAXLEN_DIRFULLPATH + 1];
	char	work_mbs[MAX_PATH];
	USHORT	uswork;
	int		i, j;
#if PLAYER_VERSION==15
	WCHAR	displaynameU[MAXCHARS_DIRNAMEU + 1];
#endif

	fwrite(info->dirname_mbs, 1, DL_DISPLAYNAME_LEN, Fdl);		// ディレクトリ表示名(SJIS)
#if PLAYER_VERSION==15
	memset(displaynameU, 0, sizeof(WCHAR)*(MAXCHARS_DIRNAMEU + 1));
	fwrite(displaynameU, 1, DL_DISPLAYNAMEU_LEN, Fdl);			// ディレクトリ表示名(UNICODE)
#endif

	swprintf_s(dirfullpath, MAXLEN_DIRFULLPATH + 1, _T("\\"));
#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==17 || PLAYER_VERSION==18
	fwrite(dirfullpath, 1, DL_FULLDIR_LEN, Fdl);				// ディレクトリフルパス(UNICODE)
	uswork = _tcslen(dirfullpath) * sizeof(WCHAR);
	fwrite(&uswork, 1, DL_FULLDIRBYTES_LEN, Fdl);				// ディレクトリフルパスバイト数

	fwrite(info->dirname, 1, DL_DIRNAME_LEN, Fdl);				// ディレクトリ名(UNICODE)
#elif PLAYER_VERSION==15
	memset(work_mbs, 0, MAX_PATH);
	ConvertWcsToMbs2(work_mbs, MAX_PATH, dirfullpath);
	fwrite(work_mbs, 1, DL_FULLDIR_LEN, Fdl);					// ディレクトリフルパス(SJIS 8.3)
	uswork = strlen(work_mbs);
	fwrite(&uswork, 1, DL_FULLDIRBYTES_LEN, Fdl);				// ディレクトリフルパスバイト数

	memset(work_mbs, 0, MAX_PATH);
	ConvertWcsToMbs2(work_mbs, MAX_PATH, info->dirname);
	fwrite(work_mbs, 1, DL_DIRNAME_LEN, Fdl);				// ディレクトリ名
#endif

	fwrite(&(info->recno_subdir_start), 1, DL_RECNO_SUBDIR_START_LEN, Fdl);		// サブディレクトリの先頭レコード番号
	fwrite(&(info->num_subdir), 1, DL_NUM_SUBDIR_LEN, Fdl);		// サブディレクトリ数

	for (j = 0; j < DL_RECNO_PARENTDIR_LEN; j++) {				// 親ディレクトリのレコード番号
		fputc(0, Fdl);
	}
	for (j = 0; j < DL_RECNO_GRANDPARENTDIR_LEN; j++) {			// 親々ディレクトリのレコード番号
		fputc(0, Fdl);
	}

	fwrite(&(info->num_sndfile), 1, DL_NUM_SNDFILE_LEN, Fdl);		// MP3ファイル数
	fwrite(&(info->recno_sndfile), 1, DL_RECNO_SNDFILE_LEN, Fdl);	// MP3ファイルリスト先頭レコード番号
	for (j = 0; j < DL_FILLER_LEN; j++) {
		fputc(0, Fdl);
	}
#if PLAYER_VERSION==18
	for (j = 0; j < DL_IMAGELENGTH_LEN; j++) {
		fputc(0, Fdl);
	}
#endif

	// イメージデータ
#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
	for (j = 0; j < DL_IMAGEDATA_LEN; j++) {
		fputc(0, Fdl);
	}
#endif

	return TRUE;
}


/*
 *	DIR構成ファイル明細レコード書き出し
 */
BOOL WriteDirStructureFileM(LPCWSTR currentdirpath, DIRINFO* info) {
	WCHAR	dirfullpath[MAXLEN_DIRFULLPATH + 1];
	char	work_mbs[MAX_PATH];
	int		i, j;
	USHORT	uswork;
	DIRINFO* dirinfo;
#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
	BYTE	imagedata[DL_IMAGEDATA_LEN];
	USHORT	img_length;
#elif PLAYER_VERSION==15
	WCHAR	displaynameU[MAXCHARS_DIRNAMEU + 1];
#endif

	for (i = 0; i < info->num_subdir; i++) {
		fwrite(info->subdirinfo[i].dirname_mbs, 1, DL_DISPLAYNAME_LEN, Fdl);		// ディレクトリ表示名(SJIS)
#if PLAYER_VERSION==15
		memset(displaynameU, 0, (MAXCHARS_DIRNAMEU + 1)*sizeof(WCHAR));
		wcsncpy_s(displaynameU, MAXCHARS_DIRNAMEU + 1, info->subdirinfo[i].dirname_w, MAXCHARS_DIRNAMEU);
		fwrite(displaynameU, 1, DL_DISPLAYNAMEU_LEN, Fdl);			// ディレクトリ表示名(UNICODE)
#endif

		swprintf_s(dirfullpath, MAXLEN_DIRFULLPATH + 1, _T("%s\\%s"), currentdirpath, info->subdirinfo[i].dirname);
#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==17 || PLAYER_VERSION==18
		fwrite(dirfullpath, 1, DL_FULLDIR_LEN, Fdl);							// ディレクトリフルパス(UNICODE)
		uswork = _tcslen(dirfullpath) * sizeof(WCHAR);
		fwrite(&uswork, 1, DL_FULLDIRBYTES_LEN, Fdl);							// ディレクトリフルパスバイト数
		fwrite(info->subdirinfo[i].dirname, 1, DL_DIRNAME_LEN, Fdl);			// ディレクトリ名(UNICODE)
#elif PLAYER_VERSION==15
		memset(work_mbs, 0, MAX_PATH);
		ConvertWcsToMbs2(work_mbs, MAX_PATH, dirfullpath);
		fwrite(work_mbs, 1, DL_FULLDIR_LEN, Fdl);								// ディレクトリフルパス(SJIS 8.3)
		uswork = strlen(work_mbs);
		fwrite(&uswork, 1, DL_FULLDIRBYTES_LEN, Fdl);							// ディレクトリフルパスバイト数

		memset(work_mbs, 0, MAX_PATH);
		ConvertWcsToMbs2(work_mbs, MAX_PATH, info->subdirinfo[i].dirname);
		fwrite(work_mbs, 1, DL_DIRNAME_LEN, Fdl);								// ディレクトリ名
#endif

		fwrite(&(info->subdirinfo[i].recno_subdir_start), 1, DL_RECNO_SUBDIR_START_LEN, Fdl);		// サブディレクトリの先頭レコード番号
		fwrite(&(info->subdirinfo[i].num_subdir), 1, DL_NUM_SUBDIR_LEN, Fdl);						// サブディレクトリ数

		dirinfo = info->subdirinfo[i].parentdirinfo;
		if (dirinfo != NULL) {
			fwrite(&(dirinfo->recno_thisdir), 1, DL_RECNO_PARENTDIR_LEN, Fdl);				// 親ディレクトリのレコード番号
			dirinfo = dirinfo->parentdirinfo;
			if (dirinfo != NULL) {
				fwrite(&(dirinfo->recno_thisdir), 1, DL_RECNO_GRANDPARENTDIR_LEN, Fdl);		// 親々ディレクトリのレコード番号
			}
			else {
				for (j = 0; j < DL_RECNO_GRANDPARENTDIR_LEN; j++) {
					fputc(0, Fdl);
				}
			}
		}
		else {
			for (j = 0; j < (DL_RECNO_PARENTDIR_LEN + DL_RECNO_GRANDPARENTDIR_LEN); j++) {
				fputc(0, Fdl);
			}
		}

		fwrite(&(info->subdirinfo[i].num_sndfile), 1, DL_NUM_SNDFILE_LEN, Fdl);				// MP3ファイル数
		fwrite(&(info->subdirinfo[i].recno_sndfile), 1, DL_RECNO_SNDFILE_LEN, Fdl);			// MP3ファイルリスト先頭レコード番号
		printf("WriteDirStructureFileM %x %x, %x %x \n", info->subdirinfo[i].recno_thisdir, info->subdirinfo[i].recno_thisdir * 0x300
			, info->subdirinfo[i].recno_sndfile, info->subdirinfo[i].recno_sndfile * 0x400);
		for (j = 0; j < DL_FILLER_LEN; j++) {
			fputc(0, Fdl);
		}

#if PLAYER_VERSION==16 || PLAYER_VERSION==12
		// イメージデータ
		MakeLcdDataOfString(imagedata, DL_IMAGEDATA_LEN, (unsigned char *)(info->subdirinfo[i].dirname_mbs), DL_DISPLAYNAME_LEN, &img_length , &FontHan, &FontZen);
		fwrite(imagedata, 1, DL_IMAGEDATA_LEN, Fdl);
#elif PLAYER_VERSION==18
		// イメージデータ
		MakeLcdDataOfString(imagedata, DL_IMAGEDATA_LEN, (unsigned char*)(info->subdirinfo[i].dirname_mbs), DL_DISPLAYNAME_LEN, &img_length, &FontHan, &FontZen);
		fwrite(&img_length, 1, DL_IMAGELENGTH_LEN, Fdl);
		fwrite(imagedata, 1, DL_IMAGEDATA_LEN, Fdl);
#endif
	}
	for (i = 0; i < info->num_subdir; i++) {
		swprintf_s(dirfullpath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), currentdirpath, info->subdirinfo[i].dirname);
		WriteDirStructureFileM(dirfullpath, &(info->subdirinfo[i]));
	}
	return TRUE;
}


#if PLAYER_VERSION==16 || PLAYER_VERSION==12 || PLAYER_VERSION==18
/*
 *	固定文字列ファイルを作成
 */
void CreateMessageStringFile() {
	int		i;
	FILE*	fp;
	char	msg_mbs[MS_SJIS_MAXLEN + 1];
	BYTE	imagedata[MS_IMAGEDATA_LEN];
	USHORT	img_length;
	static const WCHAR* msgtab[] = {
#if PLAYER_VERSION==16
		//  "0123456789012345"
		 _T("MP3_16")			// 0
		,_T("Speaker")
		,_T("Earphone")
		,_T("DIRLST ERR")
		,_T("SNDLST ERR")
		,_T("RANDOM ERR")		// 5
		,_T("MP3 ERR")
		,_T("No HISTFILE")
		,_T("[SELECT/RETURN]")
		//  "0123456789012345"
#elif PLAYER_VERSION==12
		//  "0123456789012345678901"
		 _T("フォルダ")
		,_T("ランダム再生")
		,_T("ＬＣＤリセット")
		,_T("スピーカ")
		,_T("イヤホン")
		,_T("ステレオ")
		,_T("モノラル")
		//  "0123456789012345678901"
#elif PLAYER_VERSION==18
		//   "0123456789012345"
 		  _T("MP3_18")			// 0
		, _T("DIRLST ERR")
		, _T("SNDLST ERR")
		, _T("RANDOM ERR")		// 3
		, _T("MP3 ERR")
		, _T("No HISTFILE")
		, _T("CONTRAST")
		//   "0123456789012345"
#endif
	};
	static const int nummsg = (sizeof(msgtab) / sizeof(msgtab[0]));

	if (_wfopen_s(&fp, MESSAGESTRINGFILE, _T("wb")) == 0 && fp != NULL) {
		for (i = 0; i < nummsg; i++) {
			ConvertWcsToMbs(msg_mbs, MS_SJIS_MAXLEN + 1, msgtab[i]);
			MakeLcdDataOfString(imagedata, MS_IMAGEDATA_LEN, (unsigned char*)msg_mbs, MS_SJIS_MAXLEN, &img_length, &FontHan, &FontZen);
			fwrite(imagedata, 1, MS_IMAGEDATA_LEN, fp);
		}

		fclose(fp);
	}

}
#endif

#if PLAYER_VERSION==12

void CreateMenuData12() {
	char	msg_mbs[MS_SJIS_MAXLEN + 1];
	BYTE	imagedata1[2 * DISPLAY_DOT_WIDTH];
	BYTE	imagedata2[2 * DISPLAY_DOT_WIDTH];
	BYTE	line0[DISPLAY_DOT_WIDTH];
	BYTE	line1[DISPLAY_DOT_WIDTH];
	BYTE	line2[DISPLAY_DOT_WIDTH];
	BYTE	lineasc[256];
	USHORT  img_length;
	int		width;
	int		i;
	FILE* fout;

	if (_wfopen_s(&fout, MENUDAT12, _T("wb")) == 0 && fout != NULL) {

		// メインメニュー
		// 1,2行目
		ConvertWcsToMbs(msg_mbs, MS_SJIS_MAXLEN + 1, _T("フォルダ    "));
		MakeLcdDataOfString(imagedata1, 2 * DISPLAY_DOT_WIDTH, (unsigned char*)msg_mbs, MS_SJIS_MAXLEN, &img_length , &FontHan, &FontZen);
		ConvertWcsToMbs(msg_mbs, MS_SJIS_MAXLEN + 1, _T("ランダム再生"));
		MakeLcdDataOfString(imagedata2, 2 * DISPLAY_DOT_WIDTH, (unsigned char*)msg_mbs, MS_SJIS_MAXLEN, &img_length, &FontHan, &FontZen);
		for (i = 0; i < DISPLAY_DOT_WIDTH; i++) {
			line0[i] = imagedata1[i];
			line1[i] = (imagedata1[DISPLAY_DOT_WIDTH + i] & 0x0F);
			line1[i] |= (imagedata2[i] << 4);
			line2[i] = (imagedata2[i] >> 4);
			line2[i] |= ((imagedata2[DISPLAY_DOT_WIDTH + i] & 0x0F) << 4);
		}
		fwrite(line0, 1, DISPLAY_DOT_WIDTH, fout);
		fwrite(line1, 1, DISPLAY_DOT_WIDTH, fout);
		fwrite(line2, 1, DISPLAY_DOT_WIDTH, fout);

		// 3,4行目
		ConvertWcsToMbs(msg_mbs, MS_SJIS_MAXLEN + 1, _T("GLCDリセット"));
		MakeLcdDataOfString(imagedata1, 2 * DISPLAY_DOT_WIDTH, (unsigned char*)msg_mbs, MS_SJIS_MAXLEN, &img_length, &FontHan, &FontZen);
		ConvertWcsToMbs(msg_mbs, MS_SJIS_MAXLEN + 1, _T("スピーカ ON/OFF"));
		MakeLcdDataOfString(imagedata2, 2 * DISPLAY_DOT_WIDTH, (unsigned char*)msg_mbs, MS_SJIS_MAXLEN, &img_length, &FontHan, &FontZen);
		for (i = 0; i < DISPLAY_DOT_WIDTH; i++) {
			line0[i] = imagedata1[i];
			line1[i] = (imagedata1[DISPLAY_DOT_WIDTH + i] & 0x0F);
			line1[i] |= (imagedata2[i] << 4);
			line2[i] = (imagedata2[i] >> 4);
			line2[i] |= ((imagedata2[DISPLAY_DOT_WIDTH + i] & 0x0F) << 4);
		}
		fwrite(line0, 1, DISPLAY_DOT_WIDTH, fout);
		fwrite(line1, 1, DISPLAY_DOT_WIDTH, fout);
		fwrite(line2, 1, DISPLAY_DOT_WIDTH, fout);

		// 5行目
		ConvertWcsToMbs(msg_mbs, MS_SJIS_MAXLEN + 1, _T("ステレオ／モノラル"));
		MakeLcdDataOfString(imagedata1, 2 * DISPLAY_DOT_WIDTH, (unsigned char*)msg_mbs, MS_SJIS_MAXLEN, &img_length, &FontHan, &FontZen);
		ConvertWcsToMbs(msg_mbs, MS_SJIS_MAXLEN + 1, _T(" "));		// 6行目は表示できない
		MakeLcdDataOfString(imagedata2, 2 * DISPLAY_DOT_WIDTH, (unsigned char*)msg_mbs, MS_SJIS_MAXLEN, &img_length, &FontHan, &FontZen);
		for (i = 0; i < DISPLAY_DOT_WIDTH; i++) {
			line0[i] = imagedata1[i];
			line1[i] = (imagedata1[DISPLAY_DOT_WIDTH + i] & 0x0F);
			line1[i] |= (imagedata2[i] << 4);
		}
		fwrite(line0, 1, DISPLAY_DOT_WIDTH, fout);
		fwrite(line1, 1, DISPLAY_DOT_WIDTH, fout);

#if 0
		// オプションメニュー
		// 1,2行目
		width = MakeLcdDataOfString_10(line0a, line1a, line2a, MS_MSGIMG, (unsigned char*)"GLCDリセット");
		width = MakeLcdDataOfString_10(line0b, line1b, line2b, MS_MSGIMG, (unsigned char*)"スピーカ ON/OFF");
		for (i = 0; i < LCD_WIDTH_10; i++) {
			line1a[i] &= 0x0F;
			line1a[i] |= (line0b[i] << 4);
			line0b[i] >>= 4;
			line0b[i] |= (line1b[i] << 4);
		}
		fwrite(line0a, 1, LCD_WIDTH_10, fout);
		fwrite(line1a, 1, LCD_WIDTH_10, fout);
		fwrite(line0b, 1, LCD_WIDTH_10, fout);

		// 3,4行目
		width = MakeLcdDataOfString_10(line0a, line1a, line2a, MS_MSGIMG, (unsigned char*)"ステレオ／モノラル");
		width = MakeLcdDataOfString_10(line0b, line1b, line2b, MS_MSGIMG, (unsigned char*)" ");
		for (i = 0; i < LCD_WIDTH_10; i++) {
			line1a[i] &= 0x0F;
			line1a[i] |= (line0b[i] << 4);
			line0b[i] >>= 4;
			line0b[i] |= (line1b[i] << 4);
		}
		fwrite(line0a, 1, LCD_WIDTH_10, fout);
		fwrite(line1a, 1, LCD_WIDTH_10, fout);
		fwrite(line0b, 1, LCD_WIDTH_10, fout);

		// 5行目
		width = MakeLcdDataOfString_10(line0a, line1a, line2a, MS_MSGIMG, (unsigned char*)" ");
		width = MakeLcdDataOfString_10(line0b, line1b, line2b, MS_MSGIMG, (unsigned char*)" ");	// 6行目は表示できない
		for (i = 0; i < LCD_WIDTH_10; i++) {
			line1a[i] &= 0x0F;
			line1a[i] |= (line0b[i] << 4);
			line0b[i] >>= 4;
			line0b[i] |= (line1b[i] << 4);
		}
		fwrite(line0a, 1, LCD_WIDTH_10, fout);
		fwrite(line1a, 1, LCD_WIDTH_10, fout);
#endif

		fclose(fout);
	}
}

#endif

/*
 *	フォント情報取得
 */
BOOL InitFont() {
#if PLAYER_VERSION==16
	if (GetFontMetrics(FONT_FILE_ZEN_16_16, &FontZen) == FALSE) {
		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_ZEN_16_16);
		return FALSE;
	}
	if (GetFontMetrics(FONT_FILE_HAN_8_16, &FontHan) == FALSE) {
		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_HAN_8_16);
		return FALSE;
	}
#elif PLAYER_VERSION==12
	if (GetFontMetrics(FONT_FILE_ZEN_12_12, &FontZen) == FALSE) {
		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_ZEN_12_12);
		return FALSE;
	}
	if (GetFontMetrics(FONT_FILE_HAN_6_12, &FontHan) == FALSE) {
		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_HAN_6_12);
		return FALSE;
	}
#elif PLAYER_VERSION==18
	if (GetFontMetrics(FONT_FILE_ZEN_16_16, &FontZen) == FALSE) {
		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_ZEN_16_16);
		return FALSE;
}
	if (GetFontMetrics(FONT_FILE_HAN_8_16, &FontHan) == FALSE) {
		_tprintf(_T("GetFontMetrics error %s\n"), FONT_FILE_HAN_8_16);
		return FALSE;
	}
#else
#endif
	_tprintf(_T("InitFont OK\n"));
	return TRUE;
}

/*
 *	指定されたディレクトリパスがランダム再生特定ディレクトリかどうかを判定
 *	ディレクトリフルパス(dirpath)が特定のフォルダパス(RandomByFile)から始まるかどうかで判定する。
 */
BOOL IsRandomByFileDir(LPCWSTR dirpath) {
	int		i;
	wchar_t* p;

	for (i = 0; i < NUM_RANDOMBYFILE; i++) {
		if (RandomByFile[i] != NULL) {
			p = (wchar_t*)_tcsstr(dirpath, RandomByFile[i]);
			//printf(" %ld %ld  [%lx] \n", p, dirpath, dirpath[0]);
			if (p == dirpath) {
				wprintf(_T("IsRandomByFileDir %s\n"), dirpath);
				return TRUE;
			}
		}
	}

	return FALSE;
}

/*
 *	MPEGフレームヘッダ情報から曲の長さを取得。
 *	0xFF+0xFA または 0xFF+0xFB のバイト並びをフレームヘッダとみなしてカウントする。
 *	MP3ファイル内の最初のフレームヘッダが現れるまでのバイト数をタグサイズとする。
 */
unsigned long getIrregularTagSize(LPCWSTR inFolder, LPCWSTR mp3, int* time_sec, 
	unsigned int* sampling_rate, unsigned long* mpeg_frame_count) {
	FILE*	fp;
	WCHAR	searchfile[MAXLEN_DIRFULLPATH];
	int		c0, c1, c2, c3;
	unsigned long	tagsize = 0;
	int	i;
	int	len;
	int	bitrate_index = 0;
	int	sample_index = 0;
	int	padding;
	int	frame_len;
	unsigned char	frame[MPEG_FRAME_BUFLEN];
	static int bitrate_tab[] = { 0, 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320, 999 };
	static int sample_tab[] = { 44100, 48000, 32000, 99999 };

	*mpeg_frame_count = 0;
	swprintf_s(searchfile, MAXLEN_DIRFULLPATH, _T("%s\\%s"), inFolder, mp3);
	if (_wfopen_s(&fp, searchfile, _T("rb")) != 0 || fp == NULL) {
		printf("fopen error\n");
		return 0;
	}
	while ((c0 = fgetc(fp)) != EOF) {
		if (c0 == 0xFF) {
			if ((c1 = fgetc(fp)) == EOF) break;
			if (c1 == 0xFB || c1 == 0xFA) {
				if ((c2 = fgetc(fp)) == EOF) break;
				if ((c3 = fgetc(fp)) == EOF) break;

				(*mpeg_frame_count)++;
				if (*mpeg_frame_count == 1) {
					bitrate_index = (c2 >> 4);
					sample_index = ((c2 & 0x0C) >> 2);
				}
				//padding = ((c2 & 0x02) >> 1);
				//frame_len = int((144 * bitrate_tab[bitrate_index] * 1000 / sample_tab[sample_index]) + padding);	// フレームサイズ（ヘッダのサイズ４バイトを含む）
			} else {
				if (*mpeg_frame_count == 0) tagsize += 2;
			}
		} else {
			if (*mpeg_frame_count == 0) tagsize++;
		}
	}

	fclose(fp);

	*time_sec = (int)(*mpeg_frame_count * ((double)1152 / (double)sample_tab[sample_index]));
	//printf("getIrregularTagSize padsize=%d br=%d sr=%d frame_count=%d sec=%d \n", tagsize, bitrate_tab[bitrate_index], sample_tab[sample_index], *mpeg_frame_count, *time_sec);
	return tagsize;
}


/*
 *	MPEGフレームヘッダ情報から曲の長さを取得
 */
void getMpegFrameHeaderInfo(LPCWSTR inFolder, LPCWSTR mp3, unsigned int id3v2_tag_size, int *time_sec, 
		unsigned int *sampling_rate, unsigned long *mpeg_frame_count) {
	FILE* fp;
	int	i;
	int	len;
	int	bitrate_index;
	int	sample_index;
	int	padding;
	int	frame_len;
	WCHAR	searchfile[MAXLEN_DIRFULLPATH];
	unsigned char	frame[MPEG_FRAME_BUFLEN];
	//unsigned int	mpeg_frame_count;
	static int bitrate_tab[] = {0, 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320, 999};
	static int sample_tab[] = {44100, 48000, 32000, 99999};

	*mpeg_frame_count = 0;
	swprintf_s(searchfile, MAXLEN_DIRFULLPATH, _T("%s\\%s"), inFolder, mp3);
	if (_wfopen_s(&fp, searchfile, _T("rb")) != 0 || fp == NULL) {
		printf("fopen error\n");
		return;
	}
	if (fseek(fp, id3v2_tag_size, SEEK_SET) != 0) {
		fclose(fp);
		return;
	}
	sample_index = -1;
	// MPEG 1 Layer 3 を前提して 0xFF 0xFB または 0xFF 0xFA の回数をカウント
	while (1) {
		if (fread(frame, 1, 4, fp) == 4) {		// MPEG フレームヘッダ　４バイト（XINGヘッダを考慮しない）
			if (frame[0] == 0xFF && (frame[1] == 0xFB || frame[1] == 0xFA)) {
				(*mpeg_frame_count)++;
				bitrate_index = (frame[2] >> 4);
				sample_index = ((frame[2] & 0x0C) >> 2);
				padding = ((frame[2] & 0x02) >> 1);
				frame_len = int((144 * bitrate_tab[bitrate_index] * 1000 / sample_tab[sample_index]) + padding);	// フレームサイズ（ヘッダのサイズ４バイトを含む）
				//printf(" bitrate=%d sampling rate=%d frame_len=%d \n", bitrate_tab[bitrate_index], sample_tab[sample_index], frame_len);
				if (frame_len > 4) fseek(fp, frame_len - 4, SEEK_CUR);
				else {
					printf("frame error (2)\n");
					break;
				}
			} else if (frame[0] == 'T' && frame[1] == 'A' && frame[2] == 'G'){
				// ID3v1 tag
				break;
			} else {
				printf("frame error (1)\n");
				break;
			}
		} else break;
	}
	if (sample_index >= 0 && sample_index <= 3) {
		*sampling_rate = sample_tab[sample_index];
		*time_sec = *mpeg_frame_count * ((double)1152 / (double)sample_tab[sample_index]);
	} else {
		*sampling_rate = 0;
		*time_sec = 0;
	}
	//printf("tag=%ld, mpeg_frame_count=%ld second=%d\n", id3v2_tag_size, *mpeg_frame_count, *time_sec);
	fclose(fp);
}


/*
 *	mp3ファイルのタグ情報から必要なものを取得
 *		title : 曲のタイトルをUTF16で取得する。末尾にNULL文字をセットする。
 *		titlebufsize : titleバッファの文字サイズ
 *		*titlelen : タイトルの文字数。タイトルを取得できないときはマイナス。
 *
 *	https://www.mars.org/mailman/public/mad-dev/2002-January/000439.html
 */
void getID3TagInfo(LPCWSTR inFolder, LPCWSTR mp3, WCHAR* title, int titlebufsize, int* titlelen, unsigned long * paddedsize) {
	WCHAR		mp3file[512];
	struct id3_file* id3_file;
	struct id3_tag* id3_tag;
	struct id3_frame* id3_frame;
	int			i, j, k;

	*titlelen = -1;

	swprintf_s(mp3file, 512, _T("%s\\%s"), inFolder, mp3);
	id3_file = id3_file_open_w(mp3file, ID3_FILE_MODE_READONLY);
	id3_tag = id3_file_tag(id3_file);
	for (i = 0; i < id3_tag->nframes; i++) {
		signed long encoding = 0;
		id3_frame = id3_tag->frames[i];
		if (id3_frame != NULL) {
			if (strcmp(id3_frame->id, ID3_FRAME_TITLE) == 0) {
				for (j = 0; j < id3_frame->nfields; j++) {
					union id3_field		id3_field;
					id3_field = id3_frame->fields[j];

					if (id3_field.type == ID3_FIELD_TYPE_STRINGLIST) {
						for (k = 0; k < id3_field_getnstrings(&id3_field); k++) {
							id3_ucs4_t const* ucs4_str = id3_field_getstrings(&id3_field, k);
							if (encoding == ID3_FIELD_TEXTENCODING_UTF_16) {
								id3_utf16_t* utf16_str = id3_ucs4_utf16duplicate(ucs4_str);
								*titlelen = wcslen((wchar_t*)utf16_str);
								wcscpy_s(title, titlebufsize, (wchar_t*)utf16_str);
								free(utf16_str);
							} else if (encoding == ID3_FIELD_TEXTENCODING_ISO_8859_1) {
								// ISO_8859_1にShift-JISの文字列が入っていることがある（反則だが）
								char	sjisbuf[512];
								int		sidx;
								for (sidx = 0; sidx < 512; sidx++) {
									sjisbuf[sidx] = (ucs4_str[sidx] & 0xFF);
									if (ucs4_str[sidx] == 0) break;
								}
								// sjisをWCSに変換
								ConvertMbsToWcs(sjisbuf, title, titlebufsize);
								*titlelen = wcslen(title);
							}
						}
					} else if (id3_field.type == ID3_FIELD_TYPE_TEXTENCODING) {
						encoding = id3_field.number.value;
					}
				}
			}
		}
	}
	*paddedsize = id3_tag->paddedsize;
	id3_file_close(id3_file);
}

/*
 *	mp3ファイルのID3タグ情報を取得するテストプログラム
 *	(/usr/local/include/id3tag.h参照)
 *	https://www.mars.org/mailman/public/mad-dev/2002-January/000439.html
 */
void getID3TagInfoTest(FILE* fout, LPCWSTR inFolder, LPCWSTR mp3) {
	WCHAR		mp3file[512];
	struct id3_file* id3_file;
	struct id3_tag* id3_tag;
	struct id3_frame* id3_frame;
	char		utfbuf[512];
	char		sjisbuf[512];
	int			i, j, k;

	ConvertWcsToMbs2(sjisbuf, 512, mp3);		// ファイル名のSJIS
	fprintf(fout, "%s\n", sjisbuf);

	swprintf_s(mp3file, 512, _T("%s\\%s"), inFolder, mp3);
	id3_file = id3_file_open_w(mp3file, ID3_FILE_MODE_READONLY);
	id3_tag = id3_file_tag(id3_file);

	fprintf(fout, "id3_tag refcount=%d\n", id3_tag->refcount);
	//fprintf(fout, "id3_tag version=%d\n", id3_tag->version);
	fprintf(fout, "id3_tag version=0x%x\n", id3_tag->version);
	fprintf(fout, "id3_tag flags=%d\n", id3_tag->flags);
	fprintf(fout, "id3_tag extendedflags=%d\n", id3_tag->extendedflags);
	fprintf(fout, "id3_tag restrictions=%d\n", id3_tag->restrictions);
	fprintf(fout, "id3_tag options=%d\n", id3_tag->options);
	fprintf(fout, "id3_tag paddedsize=%ld\n", id3_tag->paddedsize);
	fprintf(fout, "id3_tag nframes=%d\n", id3_tag->nframes);
	for (i = 0; i < id3_tag->nframes; i++) {
		signed long encoding = 0;
		fprintf(fout, " frames[%d]\n", i);
		id3_frame = id3_tag->frames[i];
		if (id3_frame != NULL) {
			//printf("%d ID=%s desc=%s nfields=%d\n", i, id3_frame->id, id3_frame->description, id3_frame->nfields);
			fprintf(fout, " ID=%s nfields=%d\n", id3_frame->id, id3_frame->nfields);
			for (j = 0; j < id3_frame->nfields; j++) {
				union id3_field		id3_field;
				id3_field = id3_frame->fields[j];

				fprintf(fout, "  fields[%d]\n", j);
				//printf(" field=%d id3_field_type=%d \n", j, id3_field.type);
				switch (id3_field.type) {
				case ID3_FIELD_TYPE_TEXTENCODING:
					fprintf(fout, "   ID3_FIELD_TYPE_TEXTENCODING value=%ld ", id3_field.number.value); 
					encoding = id3_field.number.value;	// encodingを覚えておく必要はない(?)
					if (encoding == ID3_FIELD_TEXTENCODING_UTF_16) {
						fprintf(fout, "ID3_FIELD_TEXTENCODING_UTF_16");
					} else if (encoding == ID3_FIELD_TEXTENCODING_ISO_8859_1) {
						fprintf(fout, "ID3_FIELD_TEXTENCODING_ISO_8859_1");
					} else if (encoding == ID3_FIELD_TEXTENCODING_UTF_16BE) {
						fprintf(fout, "ID3_FIELD_TEXTENCODING_UTF_16BE");
					} else if (encoding == ID3_FIELD_TEXTENCODING_UTF_8) {
						fprintf(fout, "ID3_FIELD_TEXTENCODING_UTF_8");
					}
					fprintf(fout, " \n");
					break;
				case ID3_FIELD_TYPE_LATIN1:
					fprintf(fout, "   ID3_FIELD_TYPE_LATIN1 [%s]\n", (char *)id3_field.latin1.ptr);
					//fprintf(fout, " ID3_FIELD_TYPE_LATIN1 : %s\n", id3_field.latin1.ptr);
					break;
				case ID3_FIELD_TYPE_LATIN1FULL:
					fprintf(fout, "   ID3_FIELD_TYPE_LATIN1FULL [%s]\n", (char *)id3_field.latin1.ptr);
					//fprintf(fout, " ID3_FIELD_TYPE_LATIN1FULL : %s\n", id3_field.latin1.ptr);
					break;
				case ID3_FIELD_TYPE_LATIN1LIST:
					fprintf(fout, "   ID3_FIELD_TYPE_LATIN1LIST \n"); 
					for (k = 0; k < id3_field.latin1list.nstrings; k++) {
						fprintf(fout, "    [%s]\n", id3_field.latin1list.strings[k]);
					}
					break;
				case ID3_FIELD_TYPE_STRING:
					fprintf(fout, "   ID3_FIELD_TYPE_STRING [%s]\n", (char *)id3_field.string.ptr);
					//fprintf(fout, " ID3_FIELD_TYPE_STRING : %s\n", id3_field.string.ptr);
					{
						const id3_ucs4_t* ucs4_str = id3_field_getstring(&id3_field);
						//if (encoding == ID3_FIELD_TEXTENCODING_UTF_16){
							//int bytes = convUCS4toUTF16LE(ucs4_str, utfbuf, 128);
							//iconvUTF16LEtoSJIS(utfbuf, bytes, sjisbuf, 128);
						id3_utf16_t* utf16_str = id3_ucs4_utf16duplicate(ucs4_str);
						ConvertWcsToMbs2(sjisbuf, 512, (wchar_t *)utf16_str);
						fprintf(fout, "    [%s]\n", sjisbuf);
						free(utf16_str);
						//} else if (encoding == ID3_FIELD_TEXTENCODING_ISO_8859_1){
						//	convUCS4toASCII(ucs4_str, sjisbuf, 128);
						//	fprintf(fout, " ID3_FIELD_TYPE_STRING : %s\n", sjisbuf);
						//}
					}
				break;
				case ID3_FIELD_TYPE_STRINGFULL:
					fprintf(fout, "   ID3_FIELD_TYPE_STRINGFULL [%s]\n", (char *)id3_field.string.ptr);
					//fprintf(fout, " ID3_FIELD_TYPE_STRINGFULL : %s\n", id3_field.string.ptr);
					{
						const id3_ucs4_t* ucs4_str = id3_field_getfullstring(&id3_field);
						//if (encoding == ID3_FIELD_TEXTENCODING_UTF_16){
							//int bytes = convUCS4toUTF16LE(ucs4_str, utfbuf, 128);
							//iconvUTF16LEtoSJIS(utfbuf, bytes, sjisbuf, 128);
						id3_utf16_t* utf16_str = id3_ucs4_utf16duplicate(ucs4_str);
						ConvertWcsToMbs2(sjisbuf, 512, (wchar_t*)utf16_str);
						fprintf(fout, "    [%s]\n", sjisbuf);
						free(utf16_str);
						//} else if (encoding == ID3_FIELD_TEXTENCODING_ISO_8859_1){
						//	convUCS4toASCII(ucs4_str, sjisbuf, 128);
						//	fprintf(fout, " ID3_FIELD_TYPE_STRINGFULL : %s\n", sjisbuf);
						//}
					}
				break;
				case ID3_FIELD_TYPE_STRINGLIST:
					fprintf(fout, "   ID3_FIELD_TYPE_STRINGLIST nstrings=%d\n", id3_field.stringlist.nstrings);
					//printf("nstrings=%d ", id3_field.stringlist.nstrings);
					for (k = 0; k < id3_field_getnstrings(&id3_field) /*id3_field.stringlist.nstrings*/; k++) {
						const id3_ucs4_t* ucs4_str = id3_field_getstrings(&id3_field, k);
						if (encoding == ID3_FIELD_TEXTENCODING_UTF_16){
							//int bytes = convUCS4toUTF16LE(ucs4_str, utfbuf, 128);
							//iconvUTF16LEtoSJIS(utfbuf, bytes, sjisbuf, 128);
							id3_utf16_t* utf16_str = id3_ucs4_utf16duplicate(ucs4_str);
							ConvertWcsToMbs2(sjisbuf, 512, (wchar_t*)utf16_str);
							fprintf(fout, "    ID3_FIELD_TEXTENCODING_UTF_16[%d][%s]\n", i, sjisbuf);
							free(utf16_str);
						} else if (encoding == ID3_FIELD_TEXTENCODING_ISO_8859_1){		// ISO_8859_1にShift-JISの文字列が入っていることがある
							int	ii;
							unsigned long ucs4_c;
							fprintf(fout, "    ID3_FIELD_TEXTENCODING_ISO_8859_1[%d] ", i);
							for (ii = 0; ii < 512; ii++) {
								ucs4_c = ucs4_str[ii];
								sjisbuf[ii] = (ucs4_c & 0xFF);
								//fprintf(fout, "[%x][%x][%x][%x] ", (ucs4_c & 0xFF), ((ucs4_c >> 8) & 0xFF), ((ucs4_c >> 16) & 0xFF), ((ucs4_c >> 24) & 0xFF));
								if (ucs4_c == 0) break;
							}
							fprintf(fout, "[%s] \n", sjisbuf);
							//printf("  convUCS4toASCII start\n");
							//convUCS4toASCII(ucs4_str, sjisbuf, 128);
							//printf("  convUCS4toASCII end\n");
							//fprintf(fout, " ID3_FIELD_TYPE_STRINGLIST : %s\n", sjisbuf);
						}
					}
					break;
				case ID3_FIELD_TYPE_LANGUAGE:
					fprintf(fout, "   ID3_FIELD_TYPE_LANGUAGE \n"); 
					/*
					{
						id3_ucs4_t *ucs4_str = id3_field.string.ptr;
						if (encoding == ID3_FIELD_TEXTENCODING_UTF_16){
							convUCS4toUTF16LE(ucs4_str, utfbuf, 128);
							iconvUTF16LEtoSJIS(utfbuf, 128, sjisbuf, 128);
							fprintf(fout, " ID3_FIELD_TYPE_LANGUAGE : %s\n", sjisbuf);
						} else if (encoding == ID3_FIELD_TEXTENCODING_ISO_8859_1){
							convUCS4toASCII(ucs4_str, sjisbuf, 128);
							fprintf(fout, " ID3_FIELD_TYPE_LANGUAGE : %s\n", sjisbuf);
						}
					}
					*/
					break;
				case ID3_FIELD_TYPE_FRAMEID:
					fprintf(fout, "   ID3_FIELD_TYPE_FRAMEID \n");
					break;
				case ID3_FIELD_TYPE_DATE:
					fprintf(fout, "   ID3_FIELD_TYPE_DATE \n");
					break;
				case ID3_FIELD_TYPE_INT8:
					fprintf(fout, "   ID3_FIELD_TYPE_INT8 \n");
					break;
				case ID3_FIELD_TYPE_INT16:
					fprintf(fout, "   ID3_FIELD_TYPE_INT16 \n");
					break;
				case ID3_FIELD_TYPE_INT24:
					fprintf(fout, "   ID3_FIELD_TYPE_INT24 \n");
					break;
				case ID3_FIELD_TYPE_INT32:
					fprintf(fout, "   ID3_FIELD_TYPE_INT32 \n");
					break;
				case ID3_FIELD_TYPE_INT32PLUS:
					fprintf(fout, "   ID3_FIELD_TYPE_INT32PLUS \n");
					break;
				case ID3_FIELD_TYPE_BINARYDATA:
					fprintf(fout, "   ID3_FIELD_TYPE_BINARYDATA \n");
					break;
				}
				//printf(" \n");
			}
		}
	}
	fprintf(fout, "\n");

	id3_file_close(id3_file);
}


/*
 *	AACのADTSヘッダに基づきDurationを取得(未完)
 */
void getAacFrameHeaderInfo(LPCWSTR inFolder, LPCWSTR mp3, int* time_sec) {
	FILE* fp;
	WCHAR	searchfile[MAXLEN_DIRFULLPATH];
	unsigned char	frame[MPEG_FRAME_BUFLEN];
	int bytes;

	*time_sec = 0;
#if 0
	swprintf_s(searchfile, MAXLEN_DIRFULLPATH, _T("%s\\%s"), inFolder, mp3);
	if (_wfopen_s(&fp, searchfile, _T("rb")) != 0 || fp == NULL) {
		printf("fopen error\n");
		return;
	}
	while (1) {
		long start_pos = ftell(fp);
		printf("START_POS=%lX\n", start_pos);
		if ((bytes = fread(frame, 1, MPEG_FRAME_BUFLEN, fp)) > 7) {
			int duration = 0;
			printf("bytes=%d\n", bytes);
			if (GetRealDurationAdts(frame, 0, bytes, &duration, start_pos) == 1) {
				fseek(fp, -7, SEEK_CUR);
			}
			*time_sec += duration;
			//*time_sec += GetRealDurationAdts(frame, 0, bytes);
		}
		else break;
	}
	printf("getAacFrameHeaderInfo=%d\n", *time_sec);
	*time_sec /= 1000;
	printf("getAacFrameHeaderInfo=%d\n", *time_sec);
	fclose(fp);
#endif
}


/*
 *	AACファイルのADTSヘッダからduration取得(未完)
 */
int GetRealDurationAdts(unsigned char buf[], int start, int length, int *duration, long start_pos)
{
	int idx;
	int sampl_f;
	int frm_len;
	//int duration = 0;
	double	df;
	int last_idx = start + length;
	static int Sampling[] = {96000, 88200, 64000, 48000, 44100, 32000, 24000, 22050, 16000, 12000, 11025, 8000, 7350 };
	static int SamplingNum = sizeof(Sampling) / sizeof(Sampling[0]);

	idx = start;
	*duration = 0;
	df = 0;

	while (idx < last_idx){
	//while (idx < (last_idx - 7)) {
		//for (i=0; i<(length-7); i++) {
		if (buf[idx] == 0xFF && (buf[idx + 1] & 0xF0) == 0xF0) {
			if (idx > (last_idx - 7)) {
				return 1;
			}
			int sampl = ((buf[idx + 2] >> 2) & 0x0F);
			if (sampl >= 0 && sampl < SamplingNum) {
				sampl_f = Sampling[sampl];
			}
			else {
				sampl_f = 0xFFFF;
			}

			frm_len = (((int)buf[idx + 3] & 0x03) << 11) | (((int)buf[idx + 4]) << 3) | ((buf[idx + 5] >> 5) & 0x07);
			if (sampl_f != 0xFFFF && frm_len > 0) {
				//*duration += (1024 * 1000) / sampl_f;          // 1024 or 1000 ?
				df += (double)(1024 * 1000) / (double)sampl_f;
				printf("GetRealDurationAdts duration=%f sampling_f=%d pos=%lX (%x %x %x %x %x %x %x) \n", df, sampl_f, start_pos + idx,
					buf[idx], buf[idx+1], buf[idx+2], buf[idx+3], buf[idx+4], buf[idx+5], buf[idx+6]);
				//if (sampl_f != 24000) {
				//	printf(" start_pos=%lx\n", start_pos + idx);
				//}
				
				//if ((buf[idx + 1] & 0x01) == 0x01) {	// CRC absence
				//	idx += 7;
				//}
				//else {
				//	idx += 9;
				//}
				 
				idx += frm_len;
				//if (!(buf[idx] == 0xFF && (buf[idx + 1] & 0xF0) == 0xF0)) {
				//	printf("Invalid Frame length\n");	// frm_len先に次のフレームが存在するはずだが、必ずしもそうでない!?。
				//	idx -= frm_len;
				//	idx += 7;
				//}
			}
			else {
				idx++;
			}
		}
		else {
			idx++;
		}

		*duration = (int)df;
	}
	//if (idx < last_idx) {
	//	// bufのデータがADTSの途中で切れている。次の受信データを待たないで、誤差として無視する。
	//	printf(" ADTS 持ち越しあり\n");
	//}
	//printf(" real duration=%d\n" + duration);

	//return duration;
	return 0;
}

/*
 *	名前nameが8.3形式のときTRUE
 */
BOOL CheckNameW_8_3(WCHAR* name) {
	WCHAR* c;
	int		len;
	int		i;

	c = wcsrchr(name, '.');
	if (c != NULL) {
		// 拡張子の長さ確認
		if (wcslen(c + 1) > 3) return FALSE;
		// Basenameの長さ
		len = wcslen(name) - wcslen(c);
	}
	else {		// 拡張子なし
		len = wcslen(name);
	}
	// basenameの長さ
	if (len > 8) return FALSE;

	for (i = 0; i < len; i++) {
		if (CheckCharW_8_3(name[i]) == FALSE) return FALSE;
	}
	return(TRUE);
}

/*
 *	8.3形式ファイル名に使える文字か
 */
BOOL CheckCharW_8_3(WCHAR c) {
	if ((c >= 'A' && c <= 'Z') || (c >= '0' && c <= '9') || c == '_' || c == '~') return TRUE;
	else return FALSE;
}

/*
 *	8.3形式ファイル名を生成
 *		name : 元ファイル名
 *		canname : 8.3形式ファイル名
 *		seq : 元ファイル名に8.3形式ファイル名で使用可能な文字が含まれているとき、最大６文字＋連番２文字(*seq)を出力ファイル名とする
 *		fileno : 元ファイル名に8.3形式ファイル名で使用可能な文字が含まれていないとき、filenoを出力ファイル名とする。
 */
void MakeDirnameW_8_3(WCHAR* name, WCHAR* canname, int *seqno, int *fileno) {
	int	i, j;
	int	len;
	WCHAR	tmpname[14];

	len = wcslen(name);
	j = 0;
	for (i = 0; i < len && j < 6; i++) {
		if ((name[i] >= 'A' && name[i] <= 'Z') || (name[i] >= '0' && name[i] <= '9')) {
			tmpname[j++] = name[i];
		}
		else if (name[i] >= 'a' && name[i] <= 'z') {
			tmpname[j++] = towupper(name[i]);
		}
	}
	tmpname[j] = '\0';

	if (j > 0) {
		swprintf_s(canname, 14, _T("%s%02d"), tmpname, *seqno);
		(*seqno)++;
	} else {
		swprintf_s(canname, 14, _T("%03d"), *fileno);
		(*fileno)++;
	}
}

/*
 *	マルチバイト文字を含むときTRUEを返す。
 */
BOOL HasMultibyteCharW(WCHAR* str) {
	int		i;
	int		len;

	len = wcslen(str);

	for (i = 0; i < len; i++) {
		if (str[i] >= 0x100) {
			return TRUE;
		}
		// マルチバイト文字を含む
		if (_ismbslead((unsigned char*)str, (unsigned char*)(str + i)) != 0) {
			return TRUE;
		}
	}

	return FALSE;
}

#if PLAYER_VERSION==15

/*
 *	対象ディレクトリのサブディレクトリを名前変更
 *		info:対象ディレクトリ
 *		num_dir:サブディレクトリ数
 */
void RenameSubdir(LPCWSTR targetdirpath, DIRINFO* info, int num_dir) {
	int	i;
	int	j;
	int	fileno = 1;
	WCHAR	olddirpath[MAXLEN_DIRFULLPATH];
	WCHAR	newdirpath[MAXLEN_DIRFULLPATH];

	for (i = 0; i < num_dir; i++) {
		int seqno = 1;
		WCHAR	canname[14];
		if (CheckNameW_8_3(info->subdirinfo[i].dirname) == FALSE) {
			do {
				MakeDirnameW_8_3(info->subdirinfo[i].dirname, canname, &seqno, &fileno);
				// 重複チェック
				for (j = 0; j < num_dir; j++) {
					if (wcscmp(canname, info->subdirinfo[j].dirname) == 0) break;
				}
				if (j == num_dir) break;	// 重複なし
			} while (1);
			// 変更
			swprintf_s(olddirpath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), targetdirpath, info->subdirinfo[i].dirname);
			swprintf_s(newdirpath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), targetdirpath, canname);
			if (MoveFileW(olddirpath, newdirpath) != 0) {	// 成功
				RecordDirnameChange(newdirpath, info->subdirinfo[i].dirname);
				wcscpy_s(info->subdirinfo[i].dirname, MAXCHARS_DIRNAME, canname);
			}
		} else {
			// ディレクトリ名変更記録があれば、変更前の名前を取得する
			swprintf_s(newdirpath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), targetdirpath, info->subdirinfo[i].dirname);
			GetDirNameBeforeRename(info->subdirinfo[i].dirname_w, newdirpath);
			// ディレクトリ表示名(SJIS)
			ConvertWcsToMbs(info->subdirinfo[i].dirname_mbs, DL_DISPLAYNAME_LEN + 1, info->subdirinfo[i].dirname_w);
		}
	}
}

/*
 *	対象ディレクトリの下の全MP3ファイルのファイル名変更
 */
void RenameMp3File(LPCWSTR targetdirpath, MP3INFO mp3list[], int num_mp3) {
	int	i, j;
	int	fileno = 1;
	WCHAR	oldfilepath[MAXLEN_DIRFULLPATH + MAXCHARS_MP3_NAME];
	WCHAR	newfilepath[MAXLEN_DIRFULLPATH + MAXCHARS_MP3_NAME];
	RENAMELIST* renlist;
	RENAMELIST* p;
	RENAMELIST* p2;

	// ファイル名を変更済みならば変更前後の名前リストを取得する
	renlist = GetMp3FilenameChangeList(targetdirpath);

	for (i = 0; i < num_mp3; i++) {
		WCHAR	canname[14];
		if (CheckNameW_8_3(mp3list[i].name) == FALSE) {
			do {
				swprintf_s(canname, 14, _T("%03d.mp3"), fileno++);		// 候補名
				// 重複チェック
				for (j = 0; j < num_mp3; j++) {
					if (wcscmp(canname, mp3list[j].name) == 0) break;
				}
				if (j == num_mp3) break;	// 重複なし
			} while (1);
			// 変更
			swprintf_s(oldfilepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), targetdirpath, mp3list[i].name);
			swprintf_s(newfilepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), targetdirpath, canname);
			if (MoveFileW(oldfilepath, newfilepath) != 0) {	// 成功
				RecordMp3FilenameChange(targetdirpath, mp3list[i].name, canname);
				wcscpy_s(mp3list[i].name, MAX_PATH, canname);
			}
		} else {
			// ファイル名変更記録があれば、変更前の名前を取得する
			for (p = renlist; p != NULL; p = p->next) {
				if (wcscmp(mp3list[i].name, p->newname) == 0) {
					wcscpy_s(mp3list[i].name_w, MAXCHARS_MP3_NAME, p->oldname);
					break;
				}
			}
		}
	}

	for (p = renlist; p != NULL; p = p2) {
		p2 = p->next;
		free(p);
	}
}


/*
 *	タグ情報ファイル出力
 */
void WriteTagInfFile(LPCWSTR targetdirpath, MP3INFO mp3list[], int num_mp3) {
	WCHAR		taginffilepath[512];
	FILE* fp;
	int		i;

	swprintf_s(taginffilepath, 512, _T("%s\\%s"), targetdirpath, SNDTAGINFFILE);
	if (_wfopen_s(&fp, taginffilepath, _T("wb")) != 0 || fp == NULL) return;

	for (i = 0; i < num_mp3; i++) {
		fwrite(mp3list[i].name, 1, TI_FILENAME_LEN, fp);
		fwrite(mp3list[i].title, 1, TI_TITLE_LEN, fp);
		fwrite(&(mp3list[i].titlelen), 1, TI_TITLELEN_LEN, fp);
		fwrite(&(mp3list[i].time_sec), 1, TI_TIMESEC_LEN, fp);
		fwrite(&(mp3list[i].sampling_rate), 1, TI_SAMPLINGRATE_LEN, fp);
		fwrite(&(mp3list[i].mpeg_frame_count), 1, TI_MPEGFRAMECOUNT_LEN, fp);
		fwrite(&(mp3list[i].paddedsize), 1, TI_TAGSIZE_LEN, fp);
		for (int j = 0; j < TI_FILLER_LEN; j++) {
			fputc(0, fp);
		}
	}

	fclose(fp);
}

/*
 *	タグ情報ファイル取得
 */
SNDTAGINF* GetSndTagInfList(LPCWSTR targetdirpath) {
	WCHAR		taginffilepath[512];
	FILE* fp;
	int		i;
	SNDTAGINF* p1 = NULL;
	SNDTAGINF* p2;

	swprintf_s(taginffilepath, 512, _T("%s\\%s"), targetdirpath, SNDTAGINFFILE);
	if (_wfopen_s(&fp, taginffilepath, _T("rb")) != 0 || fp == NULL) return NULL;

	while (1) {
		p2 = (SNDTAGINF*)malloc(sizeof(SNDTAGINF));
		p2->titlelen = 0;
		p2->time_sec = 0;
		p2->next = NULL;

		p2->name = (WCHAR*)malloc(TI_FILENAME_LEN);
		if (fread(p2->name, 1, TI_FILENAME_LEN, fp) < TI_FILENAME_LEN) {
			free(p2->name);
			free(p2);
			break;
		}
		p2->title = (WCHAR*)malloc(TI_TITLE_LEN);
		fread(p2->title, 1, TI_TITLE_LEN, fp);
		fread(&(p2->titlelen), 1, TI_TITLELEN_LEN, fp);
		fread(&(p2->time_sec), 1, TI_TIMESEC_LEN, fp);
		fread(&(p2->sampling_rate), 1, TI_SAMPLINGRATE_LEN, fp);
		fread(&(p2->mpeg_frame_count), 1, TI_MPEGFRAMECOUNT_LEN, fp);
		fread(&(p2->paddedsize), 1, TI_TAGSIZE_LEN, fp);
		fseek(fp, TI_FILLER_LEN, SEEK_CUR);

		p2->next = p1;
		p1 = p2;
	}
	fclose(fp);

	return p1;
}

/*
 *	GetSndTagInfListで確保したメモリを解放
 */
void FreeSndTagInfList(SNDTAGINF* p) {
	SNDTAGINF* p1;
	SNDTAGINF* p2;

	for (p1 = p; p1 != NULL; p1 = p2) {
		p2 = p1->next;
		free(p1->name);
		free(p1->title);
		free(p1);
	}

}


/*
 *	ディレクトリ名変更を記録
 */
BOOL RecordDirnameChange(WCHAR* dirpath, WCHAR* oldname) {
	WCHAR	filepath[MAXLEN_DIRFULLPATH + MAXCHARS_MP3_NAME];
	FILE* fp;

	// 旧名と同一名のファイル
	swprintf_s(filepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), dirpath, oldname);
	if (_wfopen_s(&fp, filepath, _T("w")) == 0 && fp != NULL) {
		fwprintf(fp, _T("%s"), _T("MKFLMP3"));
		fclose(fp);
	}

	// 所定ファイル
	swprintf_s(filepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), dirpath, RECORD_RENAME_DIR_FILE);
	if (_wfopen_s(&fp, filepath, _T("w, ccs=UNICODE")) == 0 && fp != NULL) {
		fwprintf(fp, _T("%s"), oldname);
		fclose(fp);
	}

#if 0
	swprintf_s(filepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), dirpath, RENAME_RECORD_FILE);
	// 存在しないファイルを"a"で開くとSJISで書き込まれてしまう(?)、という不思議な動作のため
	// 存在しないときは"w"で、存在するときは"a"で開く。
	if (GetFileAttributesW(filepath) == -1) {
		if (_wfopen_s(&fp, filepath, _T("w, ccs=UNICODE")) != 0 || fp == NULL) return FALSE;
	} else {
		if (_wfopen_s(&fp, filepath, _T("a, ccs=UNICODE")) != 0 || fp == NULL) return FALSE;
	}
	//if (_wfopen_s(&fp, filepath, _T("w, ccs=UNICODE")) == 0 && fp != NULL) {
		fwprintf(fp, _T("D\t%s"), oldname);
		fclose(fp);
	//}
#endif

	return TRUE;
}

/*
 *	変更前のディレクトリ名を取得
 */
BOOL GetDirNameBeforeRename(WCHAR* dirname_w, WCHAR* dirpath) {
	WCHAR	filepath[MAXLEN_DIRFULLPATH + MAXCHARS_MP3_NAME];
	WCHAR	oldname[RENAME_RECORD_BUF_SIZE];
	FILE* fp;
	BOOL	ret = FALSE;

	swprintf_s(filepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), dirpath, RECORD_RENAME_DIR_FILE);
	if (_wfopen_s(&fp, filepath, _T("r, ccs=UNICODE")) == 0 && fp != NULL) {
		fgetws(oldname, MAXCHARS_DIRNAME, fp);
		fclose(fp);
		wcscpy_s(dirname_w, MAXCHARS_DIRNAME, oldname);
		return TRUE;
	}
	else {
		return FALSE;
	}

#if 0
	// 
	swprintf_s(filepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), dirpath, RENAME_RECORD_FILE);
	if (_wfopen_s(&fp, filepath, _T("r, ccs=UNICODE")) == 0 && fp != NULL) {
		while (fgetws(oldname, MAXCHARS_DIRNAME, fp) != NULL) {
			if (oldname[0] == 'D') {
				wcscpy_s(dirname_w, MAXCHARS_DIRNAME, oldname + 2);
				ret = TRUE;
				break;
			}
		}
		fclose(fp);
		return ret;
	} else {
		return FALSE;
	}
#endif
}

/*
 *	MP3ファイル名変更を記録
 */
BOOL RecordMp3FilenameChange(const WCHAR* dirpath, WCHAR* oldname, WCHAR* newname) {
	WCHAR	filepath[MAXLEN_DIRFULLPATH + MAXCHARS_MP3_NAME];
	FILE* fp;
	errno_t	err;

	swprintf_s(filepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), dirpath, RECORD_RENAME_MP3_FILE);
	// 存在しないファイルを"a"で開くとSJISで書き込まれてしまう、という不思議な動作のため
	// 存在しないときは"w"で、存在するときは"a"で開く。
	if (GetFileAttributesW(filepath) == -1) {
		if (_wfopen_s(&fp, filepath, _T("w, ccs=UNICODE")) != 0 || fp == NULL) return FALSE;
	}
	else {
		if (_wfopen_s(&fp, filepath, _T("a, ccs=UNICODE")) != 0 || fp == NULL) return FALSE;
	}
	fwprintf(fp, _T("%s\t%s\n"), newname, oldname);
	fclose(fp);

#if 0
	// 
	swprintf_s(filepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), dirpath, RENAME_RECORD_FILE);
	// 存在しないファイルを"a"で開くとSJISで書き込まれてしまう(?)、という不思議な動作のため
	// 存在しないときは"w"で、存在するときは"a"で開く。
	if (GetFileAttributesW(filepath) == -1) {
		if ((err=_wfopen_s(&fp, filepath, _T("w, ccs=UNICODE"))) != 0 || fp == NULL) return FALSE;
	} else {
		if ((err=_wfopen_s(&fp, filepath, _T("a, ccs=UNICODE"))) != 0 || fp == NULL) return FALSE;
	}
	fwprintf(fp, _T("F\t%s\t%s\n"), newname, oldname);
	fclose(fp);
#endif

	return TRUE;
}

/*
 *	MP3ファイル名の変更記録を取得
 */
RENAMELIST* GetMp3FilenameChangeList(const WCHAR* dirpath) {
	WCHAR	filepath[MAXLEN_DIRFULLPATH + MAXCHARS_MP3_NAME];
	WCHAR	buf[RENAME_RECORD_BUF_SIZE];
	WCHAR*	c1;
	WCHAR*	c2;
	WCHAR*	c3;
	RENAMELIST* p1;
	RENAMELIST* p2;
	FILE* fp;

	swprintf_s(filepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), dirpath, RECORD_RENAME_MP3_FILE);
	if (_wfopen_s(&fp, filepath, _T("r, ccs=UNICODE")) != 0 || fp == NULL) return NULL;
	p1 = NULL;
	while (fgetws(buf, RENAME_RECORD_BUF_SIZE, fp) != NULL) {
		c1 = wcschr(buf, '\t');
		if (c1 == NULL) continue;
		*c1 = '\0';

		c2 = wcschr(c1 + 1, '\r');
		if (c2 != NULL) {
			*c2 = '\0';
		} else {
			c3 = wcschr(c1 + 1, '\n');
			if (c3 != NULL) *c3 = '\0';
		}

		p2 = (RENAMELIST *)malloc(sizeof(RENAMELIST));
		wcscpy_s(p2->newname, MAXCHARS_MP3_NAME, buf);
		wcscpy_s(p2->oldname, MAXCHARS_MP3_NAME, c1 + 1);
		p2->next = p1;
		p1 = p2;
	}
	fclose(fp);


#if 0
	// 
	swprintf_s(filepath, MAXLEN_DIRFULLPATH, _T("%s\\%s"), dirpath, RENAME_RECORD_FILE);
	if (_wfopen_s(&fp, filepath, _T("r, ccs=UNICODE")) != 0 || fp == NULL) return NULL;
	p1 = NULL;
	while (fgetws(buf, RENAME_RECORD_BUF_SIZE, fp) != NULL) {
		if (buf[0] == 'F') {
			c1 = wcschr(buf + 2, '\t');		// F\t を読み飛ばしたところから分解する
			if (c1 == NULL) continue;
			*c1 = '\0';

			c2 = wcschr(c1 + 1, '\r');
			if (c2 != NULL) {
				*c2 = '\0';
			} else {
				c3 = wcschr(c1 + 1, '\n');
				if (c3 != NULL) *c3 = '\0';
			}

			p2 = (RENAMELIST*)malloc(sizeof(RENAMELIST));
			wcscpy_s(p2->newname, MAXCHARS_MP3_NAME, buf + 2);
			wcscpy_s(p2->oldname, MAXCHARS_MP3_NAME, c1 + 1);
			p2->next = p1;
			p1 = p2;
		}
	}
#endif

	return p1;
}



/*
 *	INIファイル(テキスト)からCONFIGファイル(バイナリ)を作成する
 */
void CreateConfigFile() {
	FILE* fout;
	char	sjis[64];
	//char	mbs[64];
	//char	* c1, * c2;
	//unsigned char	uc;
	unsigned int	i1, i2, i3, i4;
	DWORD	ret;

	if (_wfopen_s(&fout, CONFIGFILE, _T("wb")) != 0 || fout == NULL) {
		return;
	}

	memset(sjis, 0, 64);
	ret = GetPrivateProfileStringA("MP3_15", "SSID", "", sjis, 32, INIFILE);
	if (ret > 0) {
		fwrite(sjis, 1, 32, fout);
	} else {
		printf("SSIDが不明\n");
	}

	memset(sjis, 0, 64);
	ret = GetPrivateProfileStringA("MP3_15", "PASSWORD", "", sjis, 32, INIFILE);
	if (ret > 0) {
		fwrite(sjis, 1, 32, fout);
	} else {
		printf("PASSWORDが不明\n");
	}

	memset(sjis, 0, 64);
	ret = GetPrivateProfileStringA("MP3_15", "IP", "", sjis, 32, INIFILE);
	if (ret > 0) {
		sscanf_s(sjis, "%d.%d.%d.%d", &i1, &i2, &i3, &i4);
		printf("IP=%d.%d.%d.%d\n", i1, i2, i3, i4);
		fwrite(&i1, 1, 1, fout);
		fwrite(&i2, 1, 1, fout);
		fwrite(&i3, 1, 1, fout);
		fwrite(&i4, 1, 1, fout);
	} else {
		printf("IPが不明\n");
	}

	memset(sjis, 0, 64);
	ret = GetPrivateProfileStringA("MP3_15", "PORT", "", sjis, 32, INIFILE);
	if (ret > 0) {
		sscanf_s(sjis, "%d", &i1);
		printf("PORT=%d\n", i1);
		fwrite(&i1, 1, 2, fout);
	} else {
		printf("PORTが不明\n");
	}

	memset(sjis, 0, 64);
	ret = GetPrivateProfileStringA("MP3_15", "GATEWAY", "", sjis, 32, INIFILE);
	if (ret > 0) {
		sscanf_s(sjis, "%d.%d.%d.%d", &i1, &i2, &i3, &i4);
		printf("GATEWAY=%d.%d.%d.%d\n", i1, i2, i3, i4);
		fwrite(&i1, 1, 1, fout);
		fwrite(&i2, 1, 1, fout);
		fwrite(&i3, 1, 1, fout);
		fwrite(&i4, 1, 1, fout);
	} else {
		printf("GATEWAYが不明\n");
	}

	memset(sjis, 0, 64);
	ret = GetPrivateProfileStringA("MP3_15", "NETMASK", "", sjis, 32, INIFILE);
	if (ret > 0) {
		sscanf_s(sjis, "%d.%d.%d.%d", &i1, &i2, &i3, &i4);
		printf("NEMASK=%d.%d.%d.%d\n", i1, i2, i3, i4);
		fwrite(&i1, 1, 1, fout);
		fwrite(&i2, 1, 1, fout);
		fwrite(&i3, 1, 1, fout);
		fwrite(&i4, 1, 1, fout);
	} else {
		printf("NEMASKが不明\n");
	}

	fclose(fout);
}

#endif		// end of #if PLAYER_VERSION==15
